
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

controlpanelTags:
  ;Size and hash of string 'name_of_value'
  ;db 13
  dd 0xE70CB870
  ;Size and hash of string 'id_of_value'
  ;db 11
  dd 0xE64AA98F
  ;Size and hash of string 'value'
  ;db 5
  dd 0xC5AF7B65
  ;Size and hash of string 'value:true'
  ;db 10
  dd 0xCE837A98
  ;Size and hash of string 'value:false'
  ;db 11
  dd 0xB3359240
  ;Size and hash of string 'value_yyyy'
  ;db 10
  dd 0xD8A5CC6C
  ;Size and hash of string 'value_month'
  ;db 11
  dd 0x4F3E02D6
  ;Size and hash of string 'value_dd'
  ;db 8
  dd 0xCEAB771A
  ;Size and hash of string 'value_hh'
  ;db 8
  dd 0xCECB771E
  ;Size and hash of string 'value_mm'
  ;db 8
  dd 0xCEF37723
  ;Size and hash of string 'value_ss'
  ;db 8
  dd 0xCF237729
  ;Size and hash of string 'header'
  ;db 6
  dd 0xC52E69A6
  ;Size and hash of string 'value_element'
  ;db 13
  dd 0x44D02546
  ;Size and hash of string 'rows'
  ;db 4
  dd 0xE7B81C33
  ;Size and hash of string 'value_pos'
  ;db 9
  dd 0xB92E78CE
  ;Size and hash of string 'value_max'
  ;db 9
  dd 0xB8BE7813
  ;Size and hash of string 'value_min'
  ;db 9
  dd 0xB8FE7809
  ;Size and hash of string 'empty_fields'
  ;db 12
  dd 0x83703AE2
  ;Size and hash of string 'groupitems'
  ;db 10
  dd 0x5F45EFCC
  ;Size and hash of string 'menu_protocols'
  ;db 14
  dd 0xB282191B
  ;Size and hash of string 'menu_listensession'
  ;db 18
  dd 0x8107D6F4
  ;Size and hash of string 'protocols_receiver'
  ;db 18
  dd 0xCE97EE3D
  ;Size and hash of string 'protocols_manipulator'
  ;db 21
  dd 0xA8319DCC
  ;Size and hash of string 'protocols_laborer'
  ;db 17
  dd 0x11196C1E
  ;Size and hash of string 'service_options'
  ;db 15
  dd 0xAFA45386
  ;Size and hash of string 'value_ms'
  ;db 8
  dd 0xCEF37729
  ;Size and hash of string 'row'
  ;db 3
  dd 0x3781CF7
  ;Size and hash of string 'protocol_session'
  ;db 16
  dd 0xCFAE9E28
  ;Size and hash of string 'listen_session'
  ;db 14
  dd 0x1034856F
endControlpanelTags:

actionList:
  ;Size and hash of string 'create_service'
  ;db 14
  ACTION_CREATE_SERVICE equ 0x4838EDF1
  ;Size and hash of string 'prepare_create_service'
  ;db 22
  ACTION_PREPARE_CREATE_SERVICE equ 0x24E5370D
  ;Size and hash of string 'change_settings'
  ;db 15
  ACTION_CHANGE_SETTINGS equ 0x2AB424B8
  ;Size and hash of string 'remove_row'
  ;db 10
  ACTION_REMOVE_ROW equ 0x283E0AD3
  ;Size and hash of string 'add_row'
  ;db 7
  ACTION_ADD_ROW equ 0xC3025D29
  ;Size and hash of string 'stop_and_delete_service'
  ;db 23
  ACTION_STOP_AND_DELETE_SERVICE equ 0xD1314E09
endActionList:


USE_DEFAULT_VALUE equ 0x0
USE_CURRENT_SETTINGS equ 0x1

WRITEABLE_ELEMENT equ 0x0
READABLE_ELEMENT equ 0x2
LIST_ELEMENT_READABLE equ 0x4
USE_LIST_POS equ 0x8
IS_ACTIVE_LISTENSESSION equ 0x10
LIST_SHOW_EMPTY_ELEMENTS equ 0x20

;flags for collectIntegersByEnumerationName()
SEND_AS_HIDDEN_FIELDS equ 0x1

actionName db 'action',0
nameName db 'name',0

optionReceiver db 'receiver',0
optionManipulator db 'manipulator',0
optionLaborer db 'laborer',0
optionListenSession db 'listensession',0
optionProtocolSession db 'protocolsession',0
optionsRowId db 'row_id',0
optionslistname db 'list_name',0

AMMOUNT_OF_ELEMENTS equ 34
AMMOUNT_OF_TAGS equ (endControlpanelTags-controlpanelTags)/4

pos_list_index equ (12*psize)

list_row_index equ 23
list_header_index equ 24
menu_protocols_item_index equ 25
menu_protocols_group_index equ 26
menu_item_link_index equ 27
menu_listensession_item_index equ 28
menu_listensession_group_index equ 29
protocol_drop_down_item_index equ 30
group_index equ 31
list_row_item_index equ 32
hidden_fields_index equ 33

elements:
  db 'acsii_str',0
  db 'unicode_str',0
  db 'boolean',0
  db 'char',0
  db 'short_int',0
  db 'integer',0
  db 'large_integer',0
  db 'date',0
  db 'time',0
  db 'datetime',0
  db 'progressbar',0
  db 'list',0

  db 'list_item_acsii_str',0
  db 'list_item_unicode_str',0
  db 'list_item_boolean',0
  db 'list_item_char',0
  db 'list_item_short_int',0
  db 'list_item_integer',0
  db 'list_item_large_integer',0
  db 'list_item_date',0
  db 'list_item_time',0
  db 'list_item_datetime',0
  db 'list_item_progressbar',0
  ;--db 'list_item_list',0   not allowed as in a list

  list_row_str db 'list_row',0
  list_header_str db 'list_header',0
  menu_protocols_item db 'menu_protocols_item',0
  menu_protocols_group db 'menu_protocols_group',0
  menu_item_link db 'menu_item_link',0
  menu_listensession_item db 'menu_listensession_item',0
  menu_listensession_group db 'menu_listensession_group',0
  menu_protocol_drop_down_item db 'protocol_drop_down_item',0
  group db 'group',0
  list_row_item db 'list_row_item',0
  hidden_fields db 'hidden_field',0
db 0

element_read_only db '_readonly',0
endElement_read_only:
element_extension db '.htm',0	;this is exectly 4 byte
endElement_extension:

  element_directory db '.\controlpanel\elements\'
  element_URL_buffer rb 128 ;the buffer will never overrun with the current elements

parsed_elements:
  rb AMMOUNT_OF_ELEMENTS*psize

parsed_elements_readonly:
  rb AMMOUNT_OF_ELEMENTS*psize


;------------------------------------------------------------------------------
;This function will load the elements in the memory and parse the tags
;input:
;    none
;output:
;    none
;------------------------------------------------------------------------------
PrepareElements:
call denter

xor edx,edx ;zero free size
mov pesi,elements

;(R/E)CX => pointer to list to store pointers of different elements
mov pecx,parsed_elements

if used is32
  push 0    ;no extra string in the file path
else
  xor r12,r12 ;no extra string in the file path
end if

loopThroughElements:
  mov pedi,element_URL_buffer ;reset pointer to temp string

  cpyElementName:
    lodsb      ;al => [ESI]
    test al,al
    jz copiedElementName ;jump if terminating zero byte

    stosb		 ;[edi]=>al
  jmp cpyElementName

  copiedElementName:
  push pesi ;save (R/E)SI

  if used is32
    mov esi,dword [esp+4] ;RSI => pointer to extra string to add to URL
  else
    mov rsi,r12 ;RSI => pointer to extra string to add to URL
  end if
  test pesi,pesi	; is '_readonly' string neccecery ?
  jz noExtraStringInURL

    cpyExtraString:
      lodsb
      test al,al
      jz endCpyExtraString

      stosb
    jmp cpyExtraString

    endCpyExtraString:

noExtraStringInURL:
  mov pesi,element_extension

  if endElement_extension-element_extension=4
    movsd   ;copy the extension (if 4 bytes)
  else
    push pecx  ; save ecx

    ;copy the extension
    mov ecx,endElement_extension-element_extension
    rep movsb

    pop pecx   ;restore ecx
  end if

  ;open a handle to the file
  push 0 ;flag => READ
  push element_directory
  call openFileHandle
  mov pesi,peax ;(R/E)SI => file handle
  inc peax ;failed handle is -1, make it 0
  test peax,peax ;test on failed handle
  je nextLoopThroughElements


  push pesi
  call getfilesize

  mov pedi,peax ;EDI = size of file
  inc pedi ;increment for the zero ending byte we add at the end.

  cmp pedx,pedi
  jnc enoughSizeInBuffer ;we dont need to resize the buffer

    ;get smallest size to allocate
    call GetSmallestPortionPageAllocation
    xor edx,edx

    notEnoughSizeInBuffer:
      add pedx,peax	;(R/E)DX => add free size of buffer (R/E)BX
    cmp pedx,pedi
    jc notEnoughSizeInBuffer ;we dont need to resize the buffer

    ;get new buffer with enough space
    push pedx
    call GetMemLocation
    mov pebx,peax

enoughSizeInBuffer:
  sub pedx,pedi ;substract the size of the file from the free size of the buffer

  dec pedi ;decrement the zero byte we add at the end

  ;read the file
  push pedi ;size of file to read
  push pebx ;buffer
  push pesi ;file handle
  call readfile

  mov pdword [pecx],pebx ;set pointer on the pointer list
  mov peax,pebx ;(R/E)AX => buffer

  ;add zero ending byte
  add pebx,pedi ;skip the read bytes in the buffer
  mov byte [pebx],0
  inc pebx

  mov pedi,peax

  ;close file handle
  push pesi ;file handle
  call closefile

  push pedi
  call PreParseElement

nextLoopThroughElements:
  pop pesi ;restore (R/E)SI
  add pecx,psize ;increment pointer to store string by one pointer

  cmp byte [pesi],0
jnz loopThroughElements

endLoopThroughElements:

if used is32
  mov dword [esp],element_read_only    ;add extra string '_readonly' in path string
else
  mov r12,element_read_only		;add extra string '_readonly' in path string
end if

mov pesi,elements   ;reset elements register

cmp pecx,parsed_elements_readonly ;if pointer (R/E)CX points to the parsed_elements_readonly, we did not yet parsed the _readonly files
je loopThroughElements

call dleave
ret

;------------------------------------------------------------------------------
;This function will replace the tags with a byte from 1 following by a tag index number
;input:
;    1:input string
;output:
;    none
;------------------------------------------------------------------------------
PreParseElement:
call denter

mov pedi,pdword [pebp+psize*2] ;input string
push pedi
call strlen
mov pecx,peax ;(R/E)CX => size of the input string

loopTagReplacement:
  ;search for the tag character
  mov al,'%' ;tag character
  repnz scasb
  jnz endPreParseElement ;jump, since we reached the end of the string
  jecxz endPreParseElement

  mov pesi,pedi ;(R/E)SI => save position of tag

  ;search for the next tag character
  repnz scasb
  jnz endPreParseElement ;jump, since we reached the end of the string

  mov byte [pedi-1],0 ;zero the tag char

  ;generate a hash of the tag name
  push pesi ;name of the variable
  call GenerateHashCaseInsensitiveSafe

  push pecx ;save (R/E)CX
  push pedi ;save (R/E)DI

  ;search if the tag exist and need to be replaced
  mov pedi,controlpanelTags ;(R/E)DI => list with control tags
  mov ecx,(endControlpanelTags-controlpanelTags)/4
  repnz scasd ;scan for 4 bytes at a time (scan for the hash of the tag
  jnz notFoundTagName

    ;the tag is found in the list and needs to be replaced

    ;calculate the number of this tag (1..*)
    sub pedi,controlpanelTags  ;R/E)DI => pointer of the tag+psize - begin pointer of the list with tags
    shr pedi,2 ;(R/E)DI /= 4
    mov peax,pedi

    mov byte [pesi-1],1 ;1 indicates a tag byte
    mov byte [pesi],al ;set tag byte
    inc pesi

    pop pedi ;restore (R/E)DI
    mov pecx,pdword [pesp] ;restore counter
    xchg pesi,pedi ;swap (R/E)SI and (R/E)DI
    push pedi ;save (R/E)DI
    inc pecx ;add zero byte

    rep movsb ;copy the rest of the string right afther the tag-index number

    pop pedi ;restore (R/E)DI
    pop pecx ;restore counter
  jmp loopTagReplacement

  notFoundTagName:
  pop pedi ;restore (R/E)DI
  pop pecx ;restore (R/E)CX

  dec pedi ;decrement (R/E)DI
  mov byte [pedi],'%' ;replace the placed zero byte with the tag char
  inc pecx ;increment the counter since we decrement the buffer pointer
jmp loopTagReplacement

endPreParseElement:
call dleave
ret psize

;------------------------------------------------------------------------------
;This function will send the page and replace the th bytes (starting with byte '1') while sending
;input:
;    1:psess
;    2:sess
;    3:HTTPSession
;    4:pointer to parsed page
;output:
;    none
;------------------------------------------------------------------------------
ParseAndSend:
call denter

mov peax,pdword [pebp+psize*4] ;HTTPSession
mov pedx,pdword [peax+psize*2] ;(R/E)DX => optionsQuestionmarkStringIndexedCollection

;get "action"
push actionName
push pedx ;HTTPSession
call [GetCollectionItem]
test peax,peax
jz noAction

  ;generate hash of the action
  push peax
  call GenerateHashCaseInsensitiveSafe

noAction:
if used is32
  push eax ;dword [esp] => index hash
else
  mov r12d,eax ;r12d => index hash
end if

;if action=="create_service"
cmp eax,ACTION_CREATE_SERVICE
je ActionCreateService

;if action=="change_settings"
cmp eax,ACTION_CHANGE_SETTINGS
je ChangeSettings

;if action=="add_row"
cmp eax,ACTION_ADD_ROW
je add_or_remove_row

;if action=="remove_row"
cmp eax,ACTION_REMOVE_ROW
je add_or_remove_row

;if action=="stop_and_delete_service"
cmp eax,ACTION_STOP_AND_DELETE_SERVICE
jne notActionCreateService

stop_and_delete_service:
  mov peax,pdword [pebp+psize*4] ;(R/E)AX => HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)AX => optionsQuestionmarkStringIndexedCollection

 ;get string with listensession
  push optionListenSession
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz EndStop_and_delete_service

  ;convert the listensession to integer
  push 10
  push peax
  call StrToInt ;(R/E)AX => pointer to ListenSession

  push peax ;save ListenSession

  ;check existing of the service
  push peax ;listensession
  push [cpyInternalListenSessionstructureCollection]
  call GetIndexedDwordItem ;(R/E)AX => pointer to Internal ListenSession
  test peax,peax

  pop peax ;(R/E)AX => ListenSession

  jz EndStop_and_delete_service    ;jump if the Listensession is invalid

  push peax		     ;ListenSession   (to stop)
  push pdword [pebp+psize*2] ;ProtocolSession (of this protocol)
  call [CloseListenSession]

EndStop_and_delete_service:
jmp dontExecuteAction

add_or_remove_row:
  ;get string 'list_name'
  push optionslistname
  push pedx ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pedi,peax ;(R/E)DI => name of list as string (with  'str_' or 'num_' in front of the name)
  test peax,peax
  jz dontExecuteAction
  mov pesi,peax ;(R/E)SI => list_name

  mov ecx,GDPD_IS_LIST or CPO_GEN_PROTOCOL_OPTION ;set flag GDPD_IS_LIST (GDPD_NAME_IS_INTEGER will be set if neccecery)

  lodsd
  cmp eax,'str_'
  je list_name_is_str

  cmp eax,'num_'
  jne dontExecuteAction ;unknown list_name

  push 10
  push pesi
  call StrToInt
  mov pesi,peax ;(R/E)SI => name of list

  or ecx,GDPD_NAME_IS_INTEGER ;set flag

list_name_is_str:
  ;get string with listensession
  push optionListenSession
  push pedx ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pebx,peax ;(R/E)BX => string with listensession
  test pebx,pebx
  jz noListenSession3

    ;convert the listensession to integer
    push 10
    push pebx
    call StrToInt
    mov pebx,peax ;(R/E)BX => listensession
    test pebx,pebx
    jz noListenSession3

    xor ecx,CPO_GEN_PROTOCOL_OPTION ;delete flag CPO_GEN_PROTOCOL_OPTION
    or ecx,CPO_GEN_LISTENSESSION_OPTION ;set flag CPO_GEN_LISTENSESSION_OPTION

noListenSession3:
  ;get string with protocolsession
  push optionProtocolSession
  push pedx ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pedx,peax ;(R/E)SI => string with protocolsession
  test pedx,pedx
  jz dontExecuteAction

    ;convert the protocolsession to integer
    push 10
    push pedx
    call StrToInt
    mov pedx,peax ;(R/E)DX => protocolsession
    test pedx,pedx
    jz dontExecuteAction

;Register status:
;(R/E)DX => protocolsession
;(R/E)BX => listensession
;(R/E)SI => Name of list
;(R/E)DI => Name of list as string (with  'str_' or 'num_' in front of the name)
;    ECX => flags (GDPD_IS_LIST | GDPD_NAME_IS_INTEGER | CPO_GEN_PROTOCOL_OPTION | CPO_GEN_LISTENSESSION_OPTION)

push pecx ;flags
push pesi ;name
push pedx ;psess
call findUserValueOption
test peax,peax
jz dontExecuteAction

;check if the found UserValueOption is a list
cmp dword [peax],TD_LIST
jne dontExecuteAction ;jump if not

and ecx,GDPD_IS_LIST or GDPD_NAME_IS_INTEGER ;delete all flags except for GDPD_IS_LIST | GDPD_NAME_IS_INTEGER

push 0	   ;data return value
push psize ;push len value

;push arguments for GetPluginData call
push pecx ;push flags
push pesp
add pdword [pesp],psize ;*len
push pesp
add pdword [pesp],psize*3 ;*data
push pesi ;name
push 0	  ;sess
push pebx ;listensession
push pedx ;protocolsession

mov pesi,peax ;(R/E)SI => pointer to UserValueOption structure

;get pointer to the list
call [GetPluginData]

add pesp,psize ;clear the len value from stack
pop pedx ;(R/E)DX => pointer to list

test peax,peax ;was call to GetPluginData succesful?
jz dontExecuteAction

mov pesi,pdword [pesi+8] ;(R/E)SI => MultiColumnList
test pesi,pesi
jz dontExecuteAction

sub pesp,psize*3; restore paramter flag from function GetPluginData + len and return data value
push pdword [pesp+psize] ;len
sub pesp,psize*5; restore paramter *data, name, sess, listensession and protocolsession

if used is32
  cmp dword [esp+psize*9],ACTION_REMOVE_ROW ;if action=="remove_row"
else
  cmp r12d,ACTION_REMOVE_ROW	    ;if action=="remove_row"
end if
je removeRow

;Register status:
;(R/E)DX => pointer to list
;(R/E)BX => listensession
;(R/E)SI => pointer to MultiColumnList
;(R/E)DI => Name of list as string (with  'str_' or 'num_' in front of the name)
;    ECX => flags (GDPD_IS_LIST | GDPD_NAME_IS_INTEGER | CPO_GEN_PROTOCOL_OPTION | CPO_GEN_LISTENSESSION_OPTION)

push pedi  ;Name of list as string (with  'str_' or 'num_' in front of the name)
push pdword [pebp+psize*4] ;HTTPSession
push pesi ;MultiColumnList
push pedx ;list
call AddRowByRequestString

;save the new list to disk
call [SavePluginData] ;paramters where restored from GetPluginData
add pesp,psize*2 ;delete len and data value
jmp dontExecuteAction

removeRow:
  mov peax,pdword [pebp+psize*4] ;HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)DX => optionsQuestionmarkStringIndexedCollection

  ;get string with protocolsession
  push optionsRowId
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz errRemoveRow

    ;convert the protocolsession to integer
    push 10
    push peax
    call StrToInt
    test pedx,pedx
    jz errRemoveRow

  push peax ;rowId
  push pedx ;list
  call [RemoveListRow]

  ;save the new list to disk
  call [SavePluginData] ;paramters where restored from GetPluginData
  add pesp,psize*2 ;delete len and data value

  jmp dontExecuteAction

errRemoveRow:
add pesp,psize*9 ;remove parameter for SavePluginData from stack

jmp dontExecuteAction

;if action=="change_settings"
ChangeSettings:
  ;get string with listensession
  push optionListenSession
  push pedx ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pebx,peax ;(R/E)BX => string with listensession
  test pebx,pebx
  jz noListenSession1

    ;convert the listensession to integer
    push 10
    push pebx
    call StrToInt
    mov pebx,peax ;(R/E)BX => listensession
    test peax,peax
    jnz changeListenSession

noListenSession1:
  ;get string with protocolsession
  push optionProtocolSession
  push pedx ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pesi,peax ;(R/E)SI => string with protocolsession
  test pesi,pesi
  jz dontExecuteAction

    ;convert the protocolsession to integer
    push 10
    push pesi
    call StrToInt
    mov pedx,peax ;(R/E)DX => protocolsession
    test pedx,pedx
    jz dontExecuteAction

;---------------
;change protocol settings
;---------------
xor ecx,ecx; zero counter
inc ecx      ;counter =1
jmp onlySaveProtocolSettings

changeListenSession:
;lock list with internalListenStructures
push [cpyInternalListenSessionstructureCollection]
call LockListWriteAcces

;get internalListenStructure
push pebx
push [cpyInternalListenSessionstructureCollection]
call GetIndexedDwordItem
test peax,peax
jz endChangeListenSession

mov pesi,pdword [peax] ;(R/E)SI => bindedToHandles
mov ecx,dword [pesi]   ;ECX = counter

if used is64
  lodsq ;skip reserved and counter
else
  add esi,8 ;skip reserved and counter
end if

jecxz endLoopThroughBindedToHandles2

loopThroughBindedToHandles2:
  lodsp ;get protocolsession
  mov pedx,peax ;(R/E)DX => protocolsession

onlySaveProtocolSettings:
  ;create an BindStruct from the receiver protocol
  push pdword [pebp+psize*4] ;HTTP session
  push 0		     ;type
  push pedx		     ;protocolsession
  call CreateBindStruct ;create a bindstruct for the receiver protocol
  test peax,peax
  jz nextLoopThroughBindedToHandles2

  push peax ;push for FreeBindStruct

  if used is64
    mov r13d,ecx ;save counter
  else
    push ecx	;save counter
  end if

  mov pedi,pdword [peax+psize+8+psize] ;(R/E)SI => initOptions
  test pedi,pedi
  jz endLoopThroughBindInitOptions

  mov ecx,dword [pedi] ;ECX = counter

  add pedi,8 ;skip reserved and counter
  sub ecx,8  ;adjust counter
  jbe endLoopThroughBindInitOptions

  loopThroughBindInitOptions:
    ;save the data for the plugin in this listensession
    if used is32
      push dword [(edi+psize*2)+4]	;flags
      push dword [edi+psize*2]		;len
    else
      mov eax,dword [(rdi+psize*2)+4]	;EAX = flags
      push rax				;flags
      mov eax,dword [rdi+psize*2]	;(R/E)AX => &len
      push peax 			;len
    end if
    push pdword [pedi+psize*1]		;data
    push pdword [pedi]			;name
    push 0				;ClientSession
    push pebx				;Listensession
    push pedx				;Protocolsession
    call [SavePluginData]

    add pedi,(psize*2)+8 ;get to next BindInitOption
    sub ecx,(psize*2)+8  ;adjust counter
  ja loopThroughBindInitOptions

  endLoopThroughBindInitOptions:
  if used is64
    mov ecx,r13d ;restore counter
  else
    pop ecx	 ;restore counter
  end if

  ;push already done
  call FreeBindStruct

nextLoopThroughBindedToHandles2:
loop loopThroughBindedToHandles2

endLoopThroughBindedToHandles2:

endChangeListenSession:
test pebx,pebx ;test listensession on zero
jz dontExecuteAction

  ;unlock list with internalListenStructures
  push [cpyInternalListenSessionstructureCollection]
  call ExternalUnlockListWriteAcces
jmp dontExecuteAction

;action=="create_service"
ActionCreateService:
  xor pebx,pebx ;clear pointer to first BindStruct

  push optionReceiver
  push pedx ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz dontExecuteAction ;dont create a new service is the receiver protocol is not set

  ;convert the protocolsession to integer
  push 10
  push peax
  call StrToInt
  mov pedx,peax ;(R/E)DX => Protocolsession to receiver protocol
  test pedx,pedx
  jz dontExecuteAction ;dont create a new service is the receiver protocol is not set

  ;get manipulator protocols from input string
  push 0		     ;flags
  push optionManipulator     ;option name
  push pdword [pebp+psize*4] ;HTTP session
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call collectIntegersByEnumerationName
  mov pesi,peax ;(R/E)CX =>pointer to a list with manipulatore protocols

  ;get laborer protocols from input string
  push 0		     ;flags
  push optionLaborer	     ;option name
  push pdword [pebp+psize*4] ;HTTP session
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call collectIntegersByEnumerationName
  mov pedi,peax ;(R/E)DI =>pointer to a list with laborer protocols

  mov peax,pdword [pedi] ;(R/E)AX => ammount of laborer protocols
  test peax,peax
  jz errActionCreateService ;dont create new service is no laborer protocols where set.

  ;create an BindStruct from the receiver protocol
  push pdword [pebp+psize*4] ;HTTP session
  push PT_RECEIVER ;type
  push pedx	   ;protocolsession
  call CreateBindStruct ;create a bindstruct for the receiver protocol
  test peax,peax
  jz errActionCreateService

  mov pebx,peax ;(R/E)BX => pointer to the first BindStruct
  mov pedx,peax ;(R/E)DX => pointer to the last BindStruct

  push pesi ;save list with manipulator protocols

  lodsp ;get ammount of manipulator protocols
  mov pecx,peax
  jecxz noManipulatorsProtocols

  loopManipulatorProtocols:
    lodsp ;get ProtocolSession
    ;create an BindStruct from the manipulator protocol
    push pdword [pebp+psize*4] ;HTTP session
    push PT_MANIPULATOR        ;type
    push peax		       ;protocolsession
    call CreateBindStruct ;create a bindstruct for the manipulator protocol
    test peax,peax
    jz nextLoopManipulatorProtocols

      mov pdword [pedx+psize+8],peax ;set next BindStruct
      mov pedx,peax		     ;set last BindStruct

  nextLoopManipulatorProtocols:
  loop loopManipulatorProtocols

noManipulatorsProtocols:

  xchg pesi,pedi ;(R/E)SI => pointer to a list with laborer protocols
  lodsp ;get ammount of laborer protocols
  mov pecx,peax

  loopLaborerProtocols:

    lodsp ;get ProtocolSession
    ;create an BindStruct from the laborer protocol
    push pdword [pebp+psize*4] ;HTTP session
    push PT_LABORER	       ;type
    push peax		       ;protocolsession
    call CreateBindStruct ;create a bindstruct for the laborer protocol
    test peax,peax
    jz nextLoopLaborerProtocols

      mov pdword [pedx+psize+8],peax ;set next BindStruct
      mov pedx,peax		     ;set last BindStruct

  nextLoopLaborerProtocols:
  loop loopLaborerProtocols

  pop pesi ;restore list with manipulator protocols

mov peax,pdword [pebx+psize+8+psize] ;initOptions

mov eax,dword [peax+8+psize*2+8+psize*2+4];flags

  ;echo the name that is set in the name behine the question mark
  mov peax,pdword [pebp+psize*4] ;(R/E)AX => HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)AX => optionsQuestionmarkStringIndexedCollection

 ;get string with listensession
  push nameName
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz nextLoopParsedPage

  ;un-escape special characters
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]

  push peax ;ListenSession name
  push pebx ;pointer to first BindStruct
  push pdword [pebp+psize*2] ;psess
  call [BindToProtocol]

errActionCreateService:
  push pebx ;pointer to first BindStruct (or zero)
  call FreeBindStruct

  ;free list with manipulatore protocols
  push pecx
  call FreeMemLocation

  ;free list with laborer protocols
  push pedi
  call FreeMemLocation
jmp dontExecuteAction

notActionCreateService:

dontExecuteAction:
push [cpyInternalListenSessionstructureCollection]
call LockListWriteAcces

mov pedi,pdword [pebp+psize*5] ;pointer to parsed page
mov pesi,pedi		       ;backup of parsed page
push pedi
call strlen
mov pecx,peax ;ECX = size of parsed string
mov pedx,pecx ;EDX = backup of size

loopParsedPage:
  mov al,1 ;1=tag byte
  repnz scasb ;search for tag byte
  jnz sendLastPartOfPage

  sub pedx,pecx ;send scaned size
  dec pedx ;decrement the found '1' byte

  call shortSendDataEDX ;send ESI with size EDX
  jnz endParseAndSend ;jump if lost connection

  mov al,byte [pedi] ;get indicator of the tag we need to replace

  dec al ;%name_of_value%
  jz sendListenSessionName

  dec al ;%id_of_value%
  jz sendListenSessionId

  sub al,18 ;%menu_protocols%
  jz sendMenuProtocols

  dec al ;%menu_listensession%
  jz sendMenuListenSessions

  dec al ;%protocols_receiver%
  jz sendProtocolsReceiver

  dec al ;%protocols_manipulator%
  jz sendProtocolsManipulator

  dec al ;%protocols_laborer%
  jz sendProtocolsLaborer

  dec al ;%service_options%
  jz sendServiceOptions

  jmp nextLoopParsedPage

sendListenSessionId:
  mov peax,pdword [pebp+psize*4] ;(R/E)AX => HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)AX => optionsQuestionmarkStringIndexedCollection

 ;get string with listensession
  push optionListenSession
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz nextLoopParsedPage

  ;call shortSendString ;send string (R/E)AX
  ;Escape string and send (R/E)AX
  call shortSendStringEcape

  jmp nextLoopParsedPage

sendListenSessionName:
  ;check on current action
  if used is32
    cmp dword [esp],ACTION_PREPARE_CREATE_SERVICE
  else
    cmp r12d,ACTION_PREPARE_CREATE_SERVICE
  end if
  jne DisplayListenSessionName	;Display the name that belongs to the ListenSession

  ;echo the name that is set in the name behine the question mark
  mov peax,pdword [pebp+psize*4] ;(R/E)AX => HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)AX => optionsQuestionmarkStringIndexedCollection

 ;get string with listensession
  push nameName
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz nextLoopParsedPage

  ;un-escape special characters
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE
  push peax
  call [ConvertEscapedCharactersToBytes]

  ;call shortSendString ;send string (R/E)AX
  ;Escape string and send (R/E)AX
  call shortSendStringEcape

  ;  call shortSendString ;send (R/E)AX

  jmp nextLoopParsedPage

DisplayListenSessionName:
  ;check on current action
  if used is32
    cmp dword [esp],ACTION_STOP_AND_DELETE_SERVICE
  else
    cmp r12d,ACTION_STOP_AND_DELETE_SERVICE
  end if
  je nextLoopParsedPage

  ;lock linked-list with internal protocol structures
  call GetInternalProtocolstructureReadLock

  mov peax,pdword [pebp+psize*4] ;(R/E)AX => HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)AX => optionsQuestionmarkStringIndexedCollection

 ;get string with listensession
  push optionListenSession
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz endSendListenSessionName

  ;convert the listensession to integer
  push 10
  push peax
  call StrToInt ;(R/E)AX => pointer to ListenSession

  ;get internalListenStructure
  push peax ;listensession
  push [cpyInternalListenSessionstructureCollection]
  call GetIndexedDwordItem ;(R/E)AX => pointer to Internal ListenSession
  test peax,peax
  jz endSendListenSessionName

  mov peax,pdword [peax+(5*psize)+8+psize] ;(R/E)AX => InternalListenSession->name
  ;call shortSendString ;send string (R/E)AX
  ;Escape string and send (R/E)AX
  call shortSendStringEcape

endSendListenSessionName:
  ;unlock linked-list with internal protocol structures
  call ReleaseInternalProtocolstructureReadLock
  jmp nextLoopParsedPage

sendMenuProtocols:
  ;lock linked-list with internal protocol structures
  call GetInternalProtocolstructureReadLock

  ;send protocols menu
  mov peax,pdword [generatedMenuProtocols]
  call shortSendString ;send string EAX

  ;unlock linked-list with internal protocol structures
  call ReleaseInternalProtocolstructureReadLock
  jmp nextLoopParsedPage

sendMenuListenSessions:
   ;lock the list with Listen Sessions
   push [cpyInternalListenSessionstructureCollection]
   call LockListWriteAcces

  ;send listensession menu
  mov peax,pdword [generatedMenuListenSession]
  call shortSendString ;send string EAX

  ;unlock the list with Listen Sessions
  push [cpyInternalListenSessionstructureCollection]
  call ExternalUnlockListWriteAcces
  jmp nextLoopParsedPage

sendProtocolsReceiver:
  mov eax,PT_RECEIVER
  jmp _sendProtocolsByType

sendProtocolsManipulator:
  mov eax,PT_MANIPULATOR
  jmp _sendProtocolsByType

sendProtocolsLaborer:
  mov eax,PT_LABORER
  ;jmp _sendProtocolsByType

_sendProtocolsByType:
  push peax		     ;type
  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  call sendProtocolsByType
  jmp nextLoopParsedPage

sendServiceOptions:
  ;lock linked-list with internal protocol structures
  call GetInternalProtocolstructureReadLock
  push pesi ;save copy (R/E)SI

  ;check on current action
  if used is32
    cmp dword [esp+psize],ACTION_PREPARE_CREATE_SERVICE
  else
    cmp r12d,ACTION_PREPARE_CREATE_SERVICE
  end if
  je prepareCreateService  ;prepare a new service

  mov peax,pdword [pebp+psize*4] ;(R/E)AX => HTTPSession
  mov pesi,pdword [peax+psize*2] ;(R/E)SI => optionsQuestionmarkStringIndexedCollection

  ;get string with listensession
  push optionListenSession
  push pesi ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pebx,peax ;(R/E)BX => string with listensession
  test pebx,pebx
  jz noListenSession

  push peax		     ;value
  push optionListenSession   ;name
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call sendHiddenField

    ;convert the listensession to integer
    push 10
    push pebx
    call StrToInt
    mov pebx,peax ;(R/E)BX => listensession

noListenSession:
  ;get string with protocolsession
  push optionProtocolSession
  push pesi ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  mov pesi,peax ;(R/E)SI => string with protocolsession
  test pesi,pesi
  jz noProtocolSession

  push peax		     ;value
  push optionProtocolSession ;name
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call sendHiddenField

    ;convert the protocolsession to integer
    push 10
    push pesi
    call StrToInt
    mov pesi,peax ;(R/E)SI => protocolsession

noProtocolSession:
  mov eax,CPO_GEN_PROTOCOL_OPTION  ;set controlpanel flags
  test pebx,pebx ;check on listensession
  jz noListenSession2

    mov eax,CPO_GEN_LISTENSESSION_OPTION

    test pesi,pesi  ;is protocolsession empty?
    jz sendAllProtocolsFromListenSession  ;jump if only a listensession is selected

;Send current settings from a protocol
  noListenSession2:
  ;send settings of this protocol
  push USE_CURRENT_SETTINGS or LIST_ELEMENT_READABLE or LIST_SHOW_EMPTY_ELEMENTS   ;flags
  push peax
  push pebx		     ;lsess
  push pesi		     ;psess
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call sendProtocolSettings
jmp endSendServiceOptions

sendAllProtocolsFromListenSession:

  ;lock list with internalListenStructures
  push [cpyInternalListenSessionstructureCollection]
  call LockListWriteAcces

  push pecx ;save counter

  ;get internalListenStructure
  push pebx ;listensession
  push [cpyInternalListenSessionstructureCollection]
  call GetIndexedDwordItem
  test peax,peax
  jz endSendAllProtocolsFromListenSession

  mov pesi,pdword [peax] ;(R/E)SI => bindedToHandles
  mov ecx,dword [pesi]	 ;get counter

  if used is64
    lodsq	      ;skip counter and reserved
  else
    lodsd	      ;skip counter
  end if


  jecxz endSendAllProtocolsFromListenSession

  loopBindedHandlesAndShowSettings:
    lodsp ;get protocolsession

    push USE_CURRENT_SETTINGS or LIST_ELEMENT_READABLE or LIST_SHOW_EMPTY_ELEMENTS   ;flags
    push CPO_GEN_LISTENSESSION_OPTION
    push pebx		       ;lsess
    push peax		       ;psess
    push pdword [pebp+psize*3] ;sess
    push pdword [pebp+psize*2] ;psess
    call sendProtocolSettings

  loop loopBindedHandlesAndShowSettings

  ;jmp endSendAllProtocolsFromListenSession

endSendAllProtocolsFromListenSession:
  pop pecx ;restore counter

  ;unlock list with internalListenStructures
  push [cpyInternalListenSessionstructureCollection]
  call ExternalUnlockListWriteAcces
jmp endSendServiceOptions

;Send DEFAULT settings from the selected protocols
prepareCreateService:
  mov peax,pdword [pebp+psize*4] ;(R/E)AX => HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)AX => optionsQuestionmarkStringIndexedCollection

  push optionReceiver
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz endSendServiceOptions ;dont sendsettings if the Receiver protocol was not set

  push peax		     ;value
  push optionReceiver	     ;name
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call sendHiddenField

  ;convert the protocolsession to integer
  push 10
  push peax
  call StrToInt

  ;send settings of this protocol
  push USE_DEFAULT_VALUE or LIST_ELEMENT_READABLE    ;flags
  push CPO_GEN_LISTENSESSION_OPTION
  push 0		     ;lsess
  push peax		     ;psess
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call sendProtocolSettings

  ;get manipulator protocols from input string
  push SEND_AS_HIDDEN_FIELDS ;flags
  push optionManipulator ;option name
  push pdword [pebp+psize*4] ;HTTP session
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call collectIntegersByEnumerationName

  push pecx ;save counter
  push peax ;push for FreeMemLocation

  mov pesi,peax ;(R/E)SI => list of Manipulator protocols

  lodsp ;get counter
  mov ecx,eax ;ECX = counter
  jecxz noManipulatorProtocols

  ;loop all the manipulator protocols and show there settings
  loopManipulcatorProtocols:
    lodsp ;get protocolsession

    ;send settings from this protocol
    push USE_DEFAULT_VALUE or LIST_ELEMENT_READABLE    ;flags
    push CPO_GEN_LISTENSESSION_OPTION
    push 0		       ;lsess
    push peax		       ;psess
    push pdword [pebp+psize*3] ;sess
    push pdword [pebp+psize*2] ;psess
    call sendProtocolSettings
  loop loopManipulcatorProtocols

  noManipulatorProtocols:
  ;push already done
  call FreeMemLocation ;frre list of Manipulator protocols

  ;get Laborer protocols from input string
  push SEND_AS_HIDDEN_FIELDS ;flags
  push optionLaborer	 ;option name
  push pdword [pebp+psize*4] ;HTTP session
  push pdword [pebp+psize*3] ;sess
  push pdword [pebp+psize*2] ;psess
  call collectIntegersByEnumerationName

  push peax ;push for FreeMemLocation

  mov pesi,peax ;(R/E)SI => list of Laborer protocols

  lodsp ;get counter
  mov ecx,eax ;ECX = counter
  jecxz noLaborerProtocols

  ;loop all the Laborer protocols and show there settings
  loopLaborerProtocols2:
    lodsp ;get protocolsession

    ;send settings from this protocol
    push USE_DEFAULT_VALUE or LIST_ELEMENT_READABLE    ;flags
    push CPO_GEN_LISTENSESSION_OPTION
    push 0		       ;lsess
    push peax		       ;psess
    push pdword [pebp+psize*3] ;lsess
    push pdword [pebp+psize*2] ;psess
    call sendProtocolSettings
  loop loopLaborerProtocols2

  noLaborerProtocols:
  ;push already done
  call FreeMemLocation ;frre list of Manipulator protocols

  pop pecx ;restore counter

endSendServiceOptions:
  pop pesi ;restore copy (R/E)SI

  ;unlock linked-list with internal protocol structures
  call ReleaseInternalProtocolstructureReadLock
  jmp nextLoopParsedPage

nextLoopParsedPage:
  ;skip the indicator of the tag
  inc pedi
  sub pecx,1 ;with dec pecx, the carry flag is not effective

  mov pesi,pedi ;(R/E)SI = copy (R/E)DI
  mov pedx,pecx ;(R/E)DX = copy (R/E)CX
jc endParseAndSend
jnz loopParsedPage

jmp endParseAndSend

sendLastPartOfPage:
  sub pedx,pecx ;send scaned size
  jz endParseAndSend

  call shortSendDataEDX ;send ESI with size EDX

endParseAndSend:
push [cpyInternalListenSessionstructureCollection]
call ExternalUnlockListWriteAcces

call dleave
ret psize*4

;------------------------------------------------------------------------------
;This function will parse the request string and add a new row
;input:
;    1:pointer to list to add the rows
;    2:pointer to MultiColumnList
;    3: pointer to HTTPSession
;    4:Name of list as string (with  'str_' or 'num_' in front of the name)


;output:
;    none
;------------------------------------------------------------------------------
AddRowByRequestString:
call denter

mov peax,pdword [pebp+psize*4] ;(R/E)AX => pointer to HTTPSession
if used is64
  mov r15,pdword [peax+psize*2]  ;R15 => optionsQuestionmarkStringIndexedCollection
else
  mov peax,pdword [peax+psize*2]  ;(R/E)AX => optionsQuestionmarkStringIndexedCollection
  mov pdword [pebp+psize*4],eax  ;pdword [pebp+psize*4] => optionsQuestionmarkStringIndexedCollection
end if


mov pesi,pdword [pebp+psize*5] ;(R/E)SI => Name of list as string (with  'str_' or 'num_' in front of the name)

push pesi ;pointer to name with str_ or num_ in front
call strlen
mov ecx,eax ;ECX => size of name list
add eax,24;add space for IntToStr conversion, a zero byte and a '_' byte

push peax
call GetMemLocation
if used is32
  mov pdword [pebp+psize*5],peax
else
  mov r12,peax
end if

mov pedi,peax

rep movsb ;copy the name

mov al,'_'
stosb ;add '_'char

;(R/E)DI => pointer where the IntToStr conversion can take place
;pdword [pebp+psize*5] or r12 => pointer to column name
;pdword [pebp+psize*4] or r15 => pointer to optionsQuestionmarkStringIndexedCollection

mov pesi,pdword [pebp+psize*3] ;(R/E)SI => MultiColumnList
lodsd ;get count of rows
add pesi,4 ;skip flags

sub eax,8+psize ;skip size of size, flag and rows member
jbe endLoopThroughColumns2

if used is32
  shr eax,2 ;Size / 4 => size of member item in Row structure
else
  ;size / 3 => size of member item in Row structure
  xor edx,edx  ;zero edx
  mov ecx,3    ;(sizeof(MultiColumnList) - psize-8) / 3 = size of item member of ROW structure
  div ecx      ;EAX => size of member item in Row structure
end if

mov ecx,eax ;ECX => size of member item in Row structure
if used is32
  shr ecx,2 ;ECX => ammount of items in row /MultiColumnList
else
  shr ecx,3 ;ECX => ammount of items in row /MultiColumnList
end if

add eax,SIZE_OF_ROW ;add default size of ROW structure

mov edx,ecx ;EDX => ammount of items
shl edx,4 ;EDX => size for items*sizeof(CurrentProgress)

add eax,edx ;EAX => size to allocate for Row structure

;(R/E)DI => pointer where the IntToStr conversion can take place
;(R/E)SI => first Column structure in the MultiColumnList structure
;ECX     => ammount of items in row /MultiColumnList
;EAX     => size to allocate for Row structure
;EDX     => size for items*sizeof(CurrentProgress)
;pdword [pebp+psize*5] or r12 => pointer to column name
;pdword [pebp+psize*4] or r15 => pointer to optionsQuestionmarkStringIndexedCollection

;allocate an Row Structure
push peax
add pdword [pesp],pedx ;add size for CurentProgress structures / long long
mov edx,eax	      ;EDX => size of Row Structure
call GetMemLocation

add pedx,peax	      ;(R/E)DX => pointer to free space for structures
mov pebx,peax	      ;(R/E)BX => pointer to Row structure

if used is32
  push peax	       ;dword [esp] => pointer to begin of Row structure
  push 1	       ;reverse counter (start at 1, ++ every time instead of --)
else
  mov r13,peax	       ;r13 => pointer to begin of Row structure
  xor r14,r14	       ;r14 => reverse counter (start at 1, ++ every time instead of --)
  inc r14d
end if

add pebx,8+psize ;seek to the items[] member

;(R/E)DI => pointer where the IntToStr conversion can take place
;(R/E)SI => first Column structure in the MultiColumnList structure
;ECX     => ammount of items in row /MultiColumnList
;(R/E)DX => pointer to free space for structures
;(R/E)BX => pointer to items[] member of Row structure
;pdword [pebp+psize*5] or r12 => pointer to column name
;pdword [pebp+psize*4] or r15 => pointer to optionsQuestionmarkStringIndexedCollection
;pdword [esp+4] or r13 => pointer to begin of Row structure
;pdword [esp] or r14 => reverse counter (start at 1, ++ every time instead of --)

loopThroughColumns2:
  push 10 ;base
  push pedi
  if used is32
    push dword [esp+psize*2] ;reverse counter
  else
    push r14		     ;reverse counter
  end if
  call IntToStr

  if used is32
    push pdword [pebp+psize*5] ;columnname
    push pdword [pebp+psize*4] ;optionsQuestionmarkStringIndexedCollection
  else
    push r12 ;columnname
    push r15 ;optionsQuestionmarkStringIndexedCollection
  end if
  call [GetCollectionItem]
  test peax,peax
  jz endAddRowByRequestString ;quit is a value of the row is missing

  ;un escape special characters
  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE	 ;flags
  push peax				 ;input string
  call [ConvertEscapedCharactersToBytes]

  if used is32
    push eax   ;save value of the column
  else
    mov r8,rax ;R8 => value of the column
  end if

  mov eax,dword [pesi+psize] ;member type of structure UserValueOption

  test eax,eax
  jz setPointerAsItem ;TD_ASCII_STRING

  dec eax ;TD_UNICODE_STRING (unsupoprted)

  sub eax,2 ;TD_BOOLEAN, TD_CHAR
  jc setInteger       ;TD_BOOLEAN
  jz setPointerAsItem ;TD_CHAR

  if used is64
    sub eax,4
    jc setInteger ;TD_SHORT_INT, TD_INTEGER, TD_LARGE_INTEGER
    jz setDate	  ;TD_DATE

    sub eax,2
    jc setTime	   ;TD_TIME
    jz setDateTime ;TD_DATETIME

    dec eax
    jz setProgress ;TD_PROGRESS
  else
    sub eax,3
    jc setInteger      ;TD_SHORT_INT, TD_INTEGER
    jz setLargeInteger ;TD_LARGE_INTEGER

    sub eax,2
    jc setDate	   ;TD_DATE
    jz setTime	   ;TD_TIME

    sub eax,2
    jc setDateTime     ;TD_DATETIME
    jz setProgress     ;TD_PROGRESS
  end if

  jmp endAddRowByRequestString

;TD_ASCII_STRING, TD_CHAR
setPointerAsItem:
  if used is32
    pop pdword [pebx] ;pdword [pebx] => value
  else
    mov pdword [pebx],r8  ;pdword [pebx] => value
  end if
  jmp nextValueIsSet

setInteger:
  if used is32
    mov eax,10 ;base
    xchg eax,dword [esp] ;swap value with base
    push eax	;push value
  else
    push 10 ;base
    push r8 ;value
  end if
  call StrToInt
  mov pdword [pebx],peax ;set value
  jmp nextValueIsSet

if used is32
setLargeInteger:
  mov dword [ebx],edx ;set pointer for long long structure

  pop eax ;value

  push edx  ;pointer
  push 10   ;base
  push eax  ;value
  call StrToIntQ

  add edx,8 ;set ECX on next free space pointer
  jmp nextValueIsSet
end if

setDate:
  if used is32
    pop eax
  end if

  push endAddRowByRequestString     ;error return pointer
  push 0			    ;return the last pos read from the string
  if used is32
    push eax
  else
    push r8
  end if
  call convertDateStringToInteger
  mov pdword [pebx],peax ;set value
  jmp nextValueIsSet

setTime:
  if used is32
    pop eax
  end if

  push endAddRowByRequestString     ;error return pointer
  if used is32
    push eax
  else
    push r8
  end if
  call convertTimeStringToInteger
  mov pdword [pebx],peax ;set value
  jmp nextValueIsSet

setDateTime:
  if used is32
    pop eax
  end if

  if used is32
    push endAddRowByRequestString     ;error function
    push edx		     ;ret pointer
    push eax		     ;pointer to value
    call convertDateTimeStringToLargeInteger
    mov pdword [pebx],edx ;set value
    add edx,8
  else
    push endAddRowByRequestString     ;error function
    push r8		     ;pointer to value
    call convertDateTimeStringToLargeInteger
    mov pdword [pebx],peax ;set value
  end if
  jmp nextValueIsSet


setProgress:
  if used is32
    pop eax

    push 10
    push eax
    call StrToInt
    mov dword [edx],eax  ;set value in CurrentProgress structure
  else
    push 10
    push r8
    call StrToInt
    mov dword [pedx],eax  ;set value in CurrentProgress structure
  end if

  mov pdword [pebx],pedx ;set value

  if used is32
    mov peax,pdword [pesi+psize+8] ;defaultValue
    mov eax,dword [peax+4] ;minimum
    mov pdword [pedx+4],eax ;set minimum

    mov peax,pdword [pesi+psize+8] ;defaultValue
    mov eax,dword [peax+8] ;maximum
    mov pdword [pedx+8],eax ;set maximum
  else
    mov rax,qword [rsi+psize+8] ;defaultValue
    mov rax,qword [peax+4] ;minimum & maximum
    mov qword [pedx+4],rax ;set minimum & maximum
  end if
  add pedx,0xC ;skip to next free space
  jmp nextValueIsSet



nextValueIsSet:
  add pebx,psize ;seek to next items[] pointer

nextLoopThroughColumns2:
  if used is32
    inc dword [esp]
  else
    inc r14
  end if

  add pesi,psize*2 + 8 ;get to next column structure
  dec pecx
jnz loopThroughColumns2

endLoopThroughColumns2:

;add the row to list
if used is32
  mov peax,pdword [pesp+psize]	 ;Row structure
  sub ebx,eax
  mov dword [eax],ebx ;set size member
  push eax
else
  sub pebx,r13
  mov dword [r13],ebx ;set size member
  push r13
end if
mov peax,pdword [pebp+psize*2]

push pdword [pebp+psize*2] ;list
call [AddListRow]

endAddRowByRequestString:
if used is32
  add pesp,psize ;remove reverse counter
end if

;free pointer to Row structure
if used is32
  ;push already done
else
  push r13
end if
call FreeMemLocation

;free name
if used is32
  push pdword [pebp+psize*5]
else
  push r12
end if
call FreeMemLocation

call dleave
ret psize*4

;------------------------------------------------------------------------------
;This function will return a pointer to a UserValueOption structure
;input:
;    1:protocolsession
;    2:name
;    3: flags (only GDPD_NAME_IS_INTEGER and CPO_GEN_LISTENSESSION_OPTION and CPO_GEN_PROTOCOL_OPTION allowed)

;output:
;    none
;------------------------------------------------------------------------------
findUserValueOption:
call denter

;lock linked-list with internal protocol structures
call GetInternalProtocolstructureReadLock

;get flags and only allow GDPD_NAME_IS_INTEGER
mov ecx,dword [pebp+psize*4]
and ecx,GDPD_NAME_IS_INTEGER or CPO_GEN_LISTENSESSION_OPTION or CPO_GEN_PROTOCOL_OPTION

mov pebx,pdword [pebp+psize*3] ;(R/E)BX => name

;get the internal protocol structure
push pdword [pebp+psize*2] ;protocolsession
call GetInternalProtocolStructure
test peax,peax
jz endFindUserValueOption  ;return zero if the psess does not exist

mov pesi,pdword [peax+psize*6] ;(R/E)SI => subOptions
test pesi,pesi
cmovz peax,pesi ;zero return value
jz endFindUserValueOption

loopThroughControlPanelOptionStructure:
  ; only continue if flag GDPD_NAME_IS_INTEGER and CPO_GEN_LISTENSESSION_OPTION and CPO_GEN_PROTOCOL_OPTIONis set in both or neither
  mov eax,dword [pesi+psize+4]
  and eax,GDPD_NAME_IS_INTEGER or CPO_GEN_LISTENSESSION_OPTION or CPO_GEN_PROTOCOL_OPTION
  cmp eax,ecx
  jne nextLoopThroughControlPanelOptionStructure


    test ecx,GDPD_NAME_IS_INTEGER
    jnz compairInteger

      ;compair string
      push pdword [pesi+psize+8] ;name of ControlPanelOption
      push pebx 		 ;name we search for
      call strcmp
      test eax,eax
      jne nextLoopThroughControlPanelOptionStructure

      ;we found  the correct structure
      mov peax,pdword [pesi+psize+2+psize*7] ;(R/E)AX => pointer to a UserValueOption structure
      jmp endFindUserValueOption

  compairInteger:
    cmp pdword [pesi+psize+8],pebx
    jne nextLoopThroughControlPanelOptionStructure

      ;we found  the correct structure
      mov peax,pdword [pesi+psize+8+(psize*7)] ;(R/E)AX => pointer to a UserValueOption structure
      jmp endFindUserValueOption

nextLoopThroughControlPanelOptionStructure:
  lodsp 	 ;get pointer to next LinkedlistControlPanelOptions
  mov pesi,peax  ;(R/E)SI => pointer to next LinkedlistControlPanelOptions
  test peax,peax
jnz loopThroughControlPanelOptionStructure

endLoopThroughControlPanelOptionStructure:

endFindUserValueOption:
push peax ;save return value

;unlock linked-list with internal protocol structures
call ReleaseInternalProtocolstructureReadLock

pop peax ;restore return value

call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will free the resources allocated by CreateBindStruct
;input:
;    1:Pointer to first BindStructin linked list
;output:
;    none
;------------------------------------------------------------------------------
FreeBindStruct:
call denter

mov pesi,pdword [pebp+psize*2]
test pesi,pesi
jz endFreeBindStruct

loopFreeBindStructs:
  push pdword [pesi+psize+8+psize] ;push initOptions
  push pesi			   ;push BindStruct

  mov pesi,pdword [pesi+psize+8] ;next

  call FreeMemLocation		   ;free BindStruct
  call FreeMemLocation		   ;free initOptions

  test pesi,pesi
jnz loopFreeBindStructs


endFreeBindStruct:
call dleave
ret psize

;------------------------------------------------------------------------------
;This function will create a BindStruct structure from the protocolsession with the settings from the HTTPSession
;input:
;    1:psess
;    2:type
;    3:HTTPSession
;output:
;    pointer to BindStruct or zero on error
;------------------------------------------------------------------------------
CreateBindStruct:
call denter

mov pedi,pdword [pebp+psize*2] ;psess

;get the internal protocol structure
push pedi ;protocolsession
call GetInternalProtocolStructure
mov pebx,peax ;InternalProtocolStructure
test peax,peax
jz endCreateBindStruct	;return zero if the psess does not exist

;create BindStruct structure
push SIZEOF_BINDSTRUCT
call GetMemLocation
mov pedx,peax ;(R/E)DX => BindStruct structure

push pedx ;save BindStruct (to return)

;get the name of the protocol
mov peax,pdword [pebx+psize*2] ;copy of psess
mov peax,pdword [peax+psize*1] ;(R/E)DI => protocolName
mov pdword [pedx],peax	       ;set protocolName in BindStruct structure

mov peax,pdword [pebp+psize*3] ;type
mov pdword [pedx+psize],peax	     ;set type in BindStruct structure

mov pesi,pdword [pebx+psize*6] ;(R/E)SI => subOptions
xor ecx,ecx ;clear counter
xor edx,edx ;clear counter of long long&CurrentProgress&integer structures

test pesi,pesi
jz noSubOptions   ;jump if there are no subOptions

;count ammount of subOptions
countSuboptions:
  if used is64
    add pecx,24 ;counter+=sizeof(BindInitoption);
  else
    add pecx,16 ;counter+=sizeof(BindInitoption);
  end if

  ;in x86 TD_LARGE_INTEGER & TD_DATETIME should be a pointer to long long, create space for these structures
  ;in x86&x64 TD_PROGRESS should be a pointer to a CurrentProgress structure, create space for these structures
  mov peax,pdword [pesi+psize+8+psize*7]  ;userValue
  test peax,peax
  jz noExtraSizeNeeded

  mov eax,dword [peax] ;type

  if used is32
    cmp eax,TD_LARGE_INTEGER
    je addExtraLongLong

    cmp eax,TD_DATETIME
    je addExtraLongLong
  end if

  cmp eax,TD_PROGRESS
  je addExtraCurrentProgress

  cmp eax,TD_ASCII_STRING
  je noExtraSizeNeeded ;ASCII strings do not need extra space

  ;default variables need a sizeof(void) as extra size (except for ASCII string)
    add edx,psize
    jmp noExtraSizeNeeded

  if used addExtraLongLong
    addExtraLongLong:
      add pedx,8 ;add one long long
      jmp noExtraSizeNeeded
  end if

  addExtraCurrentProgress:
    add pedx,SIZEOF_CURRENTPROGRESS
    ;jmp noExtraSizeNeeded

  noExtraSizeNeeded:

  lodsp ;get next subOption

  mov pesi,peax
  test peax,peax
jnz countSuboptions

;Status of registers:
;(R/E)CX => ammount of subOptions * sizeof(BindInitoption)
;(R/E)BX => Interal protocolstructure
;(R/E)DI => Protocolsession
;(R/E)DX => BindStruct structure
;x86 only : EDX => ammount of long long's


add pecx,SIZEOF_BINDINITSTRUCT ;add default size of the BindInitOptions structure


mov eax,edx
shl eax,4   ;EAX = ammount long long | CurrentProgress * sizeof(CurrentProgress)

add eax,ecx ;EAX += size of BindInitOptions structure
push peax   ;push for GetMemLocation

;allocate new memory for the BindInitOptions  structure
call GetMemLocation
mov dword [peax],ecx ;fill in the size member in BindInitOptions  structure

add pecx,peax ;(R/E)CX => pointer to free long long&CurrentProgress structures
mov pedx,peax ;(R/E)DX => to BindInitOptions  structure

mov pesi,peax
add pesi,8    ;(R/E)SI => pointer to free BindInitOption  structure

mov pebx,pdword [pebx+psize*6] ;(R/E)BX => subOptions


;Status of registers:
;      (R/E)CX => pointer to free long long structure
;      (R/E)DX => pointer to BindInitOptions  structure
;      (R/E)SI => pointer to free BindInitOption  structure
;      (R/E)DI => Protocolsession
;      (R/E)BX => pointer to suboption structure

;loop subOptions
loopSuboptionsToFillBindInitOptionStructures:
  cmp pdword [pebx+psize+8+psize*7],0
  jz nextLoopSuboptionsToFillBindInitOptionStructuresBeforeNamePush ;jump if no UserValueOption structure

  ;get %id_of_value%
  if used is64
    mov eax,dword [pebx+psize+4]  ;flags
    push rax			  ;push flags
  else
    push dword [pebx+psize+4]	  ;push flags
  end if
  push pdword [pebx+psize+8]	  ;push name
  push pedi			  ;protocol session
  call getIdOptionExternal

  push peax ;push for FreeMemLocation

  push peax ;push for GetCollectionItem

  mov peax,pdword [pebp+psize*4] ;HTTPSession
  mov peax,pdword [peax+psize*2] ;(R/E)DX => optionsQuestionmarkStringIndexedCollection

  ;get value of the option
  ;push name (already pushed)
  push peax ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]

  if used is32
    xchg eax,dword [esp] ;EAX => name of this subOption, dword [esp] => value of this subOption
    push eax		 ;push name of this subOption
  else
    mov r12,rax 	 ;R12 => value of this subOption
  end if

  ;push name (already done)
  call FreeMemLocation

  if used is32
    mov eax,dword [esp] ;EAX => value of this subOption
    test eax,eax
  else
    test r12,r12
  end if
  jz nextLoopSuboptionsToFillBindInitOptionStructures ;jump if this suboption is not set

  push ETBF_UNESCAPE_ADD_SIGN_AS_SPACE ;flags
  if used is32
    push eax  ;push pointer to string
  else
    push r12  ;push pointer to string
  end if
  call [ConvertEscapedCharactersToBytes]

  mov peax,pdword [pebx+psize+8+psize*7] ;(R/E)AX => userValue
  ;--test peax,peax
  ;--jz nextLoopSuboptionsToFillBindInitOptionStructures ;jump if no UserValueOption structure

  if used is64
    mov r13,rax ;R13 => userValue (UserValueOption structure)
  end if

  mov eax,dword [peax] ;get type

  ;push return pointer
  push BindInitOptionValueIsSet

  test eax,eax	;TD_ASCII_STRING
  jz SetAsciiStringBindInitOption

  dec eax  ;TD_UNICODE_STRING
  ;jz SetUnicodeStringBindInitOption

  dec eax  ;TD_BOOLEAN
  jz SetBooleanBindInitOption

  dec eax  ;TD_CHAR
  jz SetCharBindInitOption

  if used is64
    sub eax,4  ;TD_SHORT_INT & TD_INTEGER & TD_LARGE_INTEGER
    jc SetIntegerBindInitOption
  else
    sub eax,3  ;TD_SHORT_INT & TD_INTEGER
    jc SetIntegerBindInitOption

    jz SetLongLongBindInitOption  ;TD_LARGE_INTEGER
    dec eax ;TD_DATE
  end if

  jz SetDateBindInitOption ;TD_DATE

  dec eax
  jz SetTimeBindInitOption ;TD_TIME

  sub eax,2
  jc SetDateTimeBindInitOption ;TD_DATETIME
  jz SetProgressBindInitOption ;TD_PROGRESS

  add pesp,psize ;remove return pointer
  jmp nextLoopSuboptionsToFillBindInitOptionStructures ;jump to next

SetAsciiStringBindInitOption:
  if used is32
    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8] ;get defaultValue
  else
    mov peax,pdword [r13+8] ;get defaultValue
  end if
  test peax,peax
  jz noDefaultValueToCompairTo

    if used is32
      push dword [esp+psize] ;push value for strcmp
    else
      push r12	       ;push value for strcmp
    end if
    push peax	      ;value to compair to
    call strcmp
    test eax,eax
    jz defaultValueEqualsValue ;jump if the defaultValue and current value are the same

  noDefaultValueToCompairTo:

  if used is32
    ;check if defaultValue => value
    mov eax,dword [esp+psize] ;EAX => value of this subOption
    mov dword [esi+psize],eax ;set member data in BindInitOption

    push eax ;push for strlen

  else
    mov qword [rsi+psize],r12 ;set member data in BindInitOption
    push r12 ;push for strlen
  end if

  call strlen
  inc eax ;inlucde zero byte
  mov dword [pesi+psize*2],eax ;set member len in BindInitOption

  ret ;jump to BindInitOptionValueIsSet

;SetUnicodeStringBindInitOption:

SetBooleanBindInitOption:
  if used is32
    mov eax,dword [esp+psize] ;value
    mov al,byte [eax]	      ;first byte of value
    push eax		      ;push byte

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov al,byte [eax+8] ;get defaultValue
  else
    mov al,byte [r13+8] ;get defaultValue
  end if
  add al,'0' ;int to string :)

  if used is32
    add pesp,psize
    cmp al,byte [esp-psize] ;defaultVlaue & value
    je defaultValueEqualsValue ;jump if the defaultValue and current value are the same

    mov al,byte [esp-4] ;al = first byte from value
  else
    cmp al,byte [r12]
    je defaultValueEqualsValue ;jump if the defaultValue and current value are the same

    mov al,byte [r12] ;set member data in BindInitOption
  end if

  sub al,'0' ;strTiInt :)
  mov byte [pecx],al ;set 0 or 1 in free space
  mov pdword [pesi+psize],pecx ;set member data in BindInitOption
  mov dword [pesi+psize*2],1   ;set member len in BindInitOption
  inc pecx ;set (R/E)CX on the next free spot
  ret ;jump to BindInitOptionValueIsSet

SetCharBindInitOption:
  if used is32
    mov eax,dword [esp+psize] ;value
    mov al,byte [eax]	      ;first byte of value
    push eax		      ;push byte

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8] ;get defaultValue
  else
    mov eax,dword [r13+8] ;get defaultValue
  end if

  if used is32
    add pesp,psize
    cmp al,byte [esp-psize] ;defaultVlaue & value
    je defaultValueEqualsValue ;jump if the defaultValue and current value are the same

     mov al,byte [esp-4] ;al = first byte from value
  else
    cmp al,byte [r12]
    je defaultValueEqualsValue ;jump if the defaultValue and current value are the same

    mov al,byte [r12] ;set member data in BindInitOption
  end if

  mov byte [pecx],al ;set byte in free space
  mov pdword [pesi+psize],pecx ;set member data in BindInitOption
  mov dword [pesi+psize*2],1   ;set member len in BindInitOption
  inc pecx ;set (R/E)CX on the next free spot
  ret ;jump to BindInitOptionValueIsSet

SetIntegerBindInitOption:
  if used is32
    ;convert the string to a integer
    push 10
    push dword [esp+psize*2] ;pointer to value
    call StrToInt
    push eax ;push the result of StrToInt

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8] ;get defaultValue

    ;compaire defaultValue and value
    cmp eax,dword [esp]
    pop eax ;EAX = result of StrToInt
    je defaultValueEqualsValue
  else
    ;convert the string to a integer
    push 10
    push r12 ;pointer to value
    call StrToInt

    cmp rax,qword [r13+8]  ;compaire defaultValue and value
    je defaultValueEqualsValue
  end if

  mov pdword [pecx],peax ;set convert integer in free space
  mov pdword [pesi+psize],pecx	 ;set member data in BindInitOption
  mov dword [pesi+psize*2],psize ;set member len in BindInitOption
  add pecx,psize ;set (R/E)CX on the next free spot

  ret ;jump to BindInitOptionValueIsSet

if used is32
  SetLongLongBindInitOption:

    ;convert the string to a integer
    push ecx
    push 10
    push dword [esp+psize*3] ;pointer to value
    call StrToIntQ

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8]		;get defaultValue

    push ecx ;long long (value)
    push eax ;long long (defaultValue)
    call cmpQword
    je defaultValueEqualsValue

    mov pdword [pesi+psize],pecx   ;set member data in BindInitOption
    mov dword [pesi+psize*2],8	   ;set member len in BindInitOption
    add pecx,8			   ;set (R/E)CX on the next free spot
    ret 			   ;jump to BindInitOptionValueIsSet
end if

SetDateBindInitOption:
  push errParsingValue	   ;error return pointer
  push 0		   ;return the last pos read from the string
  if used is32
    push dword [pesp+psize*3] ;pointer to value
  else
    push r12
  end if
  call convertDateStringToInteger

  if used is32
    push eax

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8]		;get defaultValue

    cmp eax,dword [esp]  ;compaire defaultValue and value
    pop eax
    je defaultValueEqualsValue
  else
    cmp eax,dword [r13+8]  ;compaire defaultValue and value
    je defaultValueEqualsValue
  end if

  mov dword [pecx],eax		 ;set the dat on the free space
  mov pdword [pesi+psize],pecx	 ;set member data in BindInitOption
  mov dword [pesi+psize*2],4	 ;set member len in BindInitOption
  add pecx,4			 ;set (R/E)CX on the next free spot
  ret ;jump to BindInitOptionValueIsSet


SetTimeBindInitOption:
  push errParsingValue	   ;error return pointer
  if used is32
    push dword [pesp+psize*2] ;pointer to value
  else
    push r12
  end if
  call convertTimeStringToInteger

  if used is32
    push eax

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8]		;get defaultValue

    cmp eax,dword [esp]  ;compaire defaultValue and value
    pop eax
    je defaultValueEqualsValue
  else
    cmp eax,dword [r13+8]  ;compaire defaultValue and value
    je defaultValueEqualsValue
  end if

  mov dword [pecx],eax		 ;set the dat on the free space
  mov pdword [pesi+psize],pecx	 ;set member data in BindInitOption
  mov dword [pesi+psize*2],4	 ;set member len in BindInitOption
  add pecx,4			 ;set (R/E)CX on the next free spot
  ret ;jump to BindInitOptionValueIsSet

SetDateTimeBindInitOption:
  if used is32
    push errParsingValue     ;error function
    push ecx		     ;ret pointer
    push dword [esp+psize*3] ;pointer to value
    call convertDateTimeStringToLargeInteger
  else
    push errParsingValue     ;error function
    push r12 ;pointer to value
    call convertDateTimeStringToLargeInteger
  end if

  if used is64
    mov qword [rcx],rax
    cmp rax,qword [r13+8]  ;compaire defaultValue and value
    je defaultValueEqualsValue
  else
    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8]		;get defaultValue

    push ecx ;long long (value)
    push eax ;long long (defaultValue)
    call cmpQword
    je defaultValueEqualsValue
  end if

  mov pdword [pesi+psize],pecx	 ;set member data in BindInitOption
  mov dword [pesi+psize*2],8	 ;set member len in BindInitOption
  add pecx,8			 ;set (R/E)CX on the next free spot
  ret ;jump to BindInitOptionValueIsSet

SetProgressBindInitOption:
  if used is32
    ;convert the string to a integer
    push 10
    push dword [esp+psize*2] ;pointer to value
    call StrToInt
    push eax ;push the result of StrToInt

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8] ;get defaultValue
    mov eax,dword [eax]   ;get curPos

    ;compaire curPos and value
    cmp eax,dword [esp]
    pop eax ;EAX = result of StrToInt
    je defaultValueEqualsValue

    mov dword [pecx],peax ;set curPos in free space

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8] ;get defaultValue
    mov eax,dword [eax+4]   ;get minimum

    mov dword [pecx+4],peax ;set minimum in free space

    mov eax,dword [ebx+psize+8+psize*7] ;(R/E)AX => userValue
    mov eax,dword [eax+8] ;get defaultValue
    mov eax,dword [eax+8]   ;get maximum

    mov dword [pecx+8],peax ;set maximum in free space
  else
    ;convert the string to a integer
    push 10
    push r12 ;pointer to value
    call StrToInt

    mov r8,qword [r13+8]  ;get defaultValue

    cmp eax,dword [r8]	 ;compaire curPos and value
    je defaultValueEqualsValue

    mov dword [pecx],eax ;set curPos in free space

    mov r9d,dword [r8+4] ;get minimum
    mov dword [pecx+4],r9d ;set minimum in free space

    mov r9d,dword [r8+8] ;get maximum
    mov dword [pecx+8],r9d ;set maximum in free space
  end if

  mov pdword [pesi+psize],pecx	 ;set member data in BindInitOption
  mov dword [pesi+psize*2],SIZEOF_CURRENTPROGRESS ;set member len in BindInitOption
  add pecx,SIZEOF_CURRENTPROGRESS ;set (R/E)CX on the next free spot
  ret ;jump to BindInitOptionValueIsSet

BindInitOptionValueIsSet:
  mov eax,dword [pebx+psize+4] ;EAX = flag
  and eax,GDPD_NAME_IS_INTEGER ;only set flag GDPD_NAME_IS_INTEGER is set (other flags are for ControlPanelOption only :))
  mov dword [pesi+(psize*2)+4],eax ;set flags in BindInitOption

  mov peax,pdword [pebx+psize+8] ;EAX = name
  mov dword [pesi],eax ;set name in BindInitOption

  add pesi,(psize*2)+8 ;get to the next BindInitOption structure
jmp nextLoopSuboptionsToFillBindInitOptionStructures

defaultValueEqualsValue:
 ;since the value is the same as the defaultValue, set value to GDPD_RESET_DATA
  mov eax,dword [pebx+psize+4] ;EAX = flag
  or eax,GDPD_RESET_DATA ;set flag GDPD_RESET_DATA
  mov dword [pesi+(psize*2)+4],eax ;set flags in BindInitOption

  mov peax,pdword [pebx+psize+8] ;EAX = name
  mov dword [pesi],eax ;set name in BindInitOption

  add pesi,(psize*2)+8 ;get to the next BindInitOption structure

errParsingValue:
 add pesp,psize ;remove return pointer
 jmp nextLoopSuboptionsToFillBindInitOptionStructures ;jump to next

nextLoopSuboptionsToFillBindInitOptionStructures:
if used is32
  pop peax ;pop name of value
end if

nextLoopSuboptionsToFillBindInitOptionStructuresBeforeNamePush:
;Status of registers:
;      (R/E)CX => pointer to free long long structure
;      (R/E)DX => pointer to BindInitOptions  structure
;      (R/E)SI => pointer to free BindInitOption  structure
;      (R/E)DI => Protocolsession
;      (R/E)BX => pointer to suboption structure

  mov pebx,pdword [pebx] ;get next subOption
  test pebx,pebx ;test on zero
jnz loopSuboptionsToFillBindInitOptionStructures

endLoopSuboptionsToFillBindInitOptionStructures:
  ;fix size member
  sub pesi,pedx
  mov dword [pedx],esi

noSubOptions:
  pop peax ;return BindStruct

  mov pdword [peax+psize+8+psize],pedx ;set initOptions

endCreateBindStruct:
call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will convert format yyyy-mm-dd to an integer with FormatDate function
;input:
;    1:string
;    2:return pointer for last read position on string
;    3:return pointer on error
;output:
;    (R/E)AX: integer created with FormatDate function
;------------------------------------------------------------------------------
convertDateStringToInteger:
call denter

mov pebx,pdword [pebp+psize*3] ;return pointer for last read position on string

  ;convert year to an integer
  push 10
  push pdword [pebp+psize*2] ;pointer to value
  call StrToIntWithBaseAsTerminator

  push peax ;push year

  mov peax,pdword [pesp-psize] ;recover the last known position of the string
  cmp byte [peax],0
  jz errConvertDateStringToInteger

  ;convert month to an integer
  push 10
  push peax ;pointer to value
  call StrToIntWithBaseAsTerminator

  push peax ;push month

  mov peax,pdword [pesp-psize] ;recover the last known position of the string
  cmp byte [peax],0
  jz errConvertDateStringToInteger

  ;convert day to an integer
  push 10
  push peax ;pointer to value
  call StrToIntWithBaseAsTerminator

  xchg peax,pdword [pesp+psize] ;swap year with day
  push peax ;push year

  mov peax,pdword [pesp-psize] ;recover the last known position of the string
  test pebx,pebx
  jz dontSetLastReadPointer

    mov pdword [pebx],peax

dontSetLastReadPointer:
  call [FormatDate]

endConvertDateStringToInteger:
call dleave
ret psize*3

errConvertDateStringToInteger:
call dleave
add pesp,psize*4	;clear return pointer and argument from stack
jmp pdword [pesp-psize] ;jump to error return pointer

;------------------------------------------------------------------------------
;This function will convert format hh:mm:ss:ms to an integer with FormatTime function
;input:
;    1:string
;    2:return pointer on error
;output:
;    (R/E)AX: integer created with FormatDate function
;------------------------------------------------------------------------------
convertTimeStringToInteger:
call denter

mov pebx,pdword [pebp+psize*3] ;return pointer for last read position on string

  ;convert hour to an integer
  push 10
  push pdword [pebp+psize*2] ;pointer to value
  call StrToIntWithBaseAsTerminator

  push peax ;push hour

  mov peax,pdword [pesp-psize] ;recover the last known position of the string
  cmp byte [peax],0
  jz errConvertTimeStringToInteger

  ;convert minutes to an integer
  push 10
  push peax ;pointer to value
  call StrToIntWithBaseAsTerminator

  push peax ;push minutes

  mov peax,pdword [pesp-psize] ;recover the last known position of the string
  cmp byte [peax],0
  jnz timeMinutesIsOk

    xor eax,eax 	    ;zero seconds
    xchg dword [pesp],eax   ;swap minutes with seconds
    push peax		    ;push minutes

    xor eax,eax 	    ;zero miliseconds
    xchg dword [pesp+psize*2],eax ;swap hours with milliseconds
    push peax		    ;push hours
    jmp doFormatTime

timeMinutesIsOk:
  ;convert seconds to an integer
  push 10
  push peax ;pointer to value
  call StrToIntWithBaseAsTerminator

  xchg peax,pdword [pesp] ;swap minutes with seconds
  push peax ;push minutes

  mov peax,pdword [pesp-psize] ;recover the last known position of the string
  cmp byte [peax],0
  jnz timeSecondsIsOk

    xor eax,eax 	    ;zero miliseconds
    xchg dword [pesp+psize*2],eax ;swap hours with milliseconds
    push peax		    ;push hours
    jmp doFormatTime

timeSecondsIsOk:
  ;convert miliseconds to an integer
  push 10
  push peax ;pointer to value
  call StrToIntWithBaseAsTerminator

  xchg dword [pesp+psize*2],eax ;swap hours with milliseconds
  push peax		  ;push hours

doFormatTime:
  call [FormatTime]

call dleave
ret psize*2

errConvertTimeStringToInteger:
call dleave
add pesp,psize*3	;clear return pointer and argument from stack
jmp pdword [pesp-psize] ;jump to error return pointer

;------------------------------------------------------------------------------
;This function will convert format yyyy-mm-dd hh:mm:ss:ms to an integer with FormatDateTime function
;input(x64):
;    1:string
;    2:return pointer on error
;input(x86):
;    1:string
;    2:return pointer for long long
;    3:return pointer on error
;output:
;    (R/E)AX: integer created with FormatDate function
;------------------------------------------------------------------------------
convertDateTimeStringToLargeInteger:
call denter

push 0
mov pecx,pesp

push errconvertDateTimeStringToLargeInteger	;error return pointer
push pecx		  ;return the last pos read from the string
push pdword [pebp+psize*2] ;pointer to value
call convertDateStringToInteger
mov edx,eax ;EDX = result of FormatDate

pop pedi ;set value to last read pos

push errconvertDateTimeStringToLargeInteger	;error return pointer
push pedi					;pointer to value
call convertTimeStringToInteger
mov ecx,eax ;ECX = result of FormatDate

retTimeConverted:

  if used is32
    push dword [ebp+psize*3] ;*retval  (pointer to free space)
  end if

  mov eax,ecx	      ;result of FormatTime
  and eax,0x1F800     ;EDX => seconds>11
  shr eax,11	      ;EDX => seconds
  push peax	      ;push seconds

  mov eax,ecx	      ;result of FormatTime
  and eax,0x7E0       ;ECX => minutes>5
  shr eax,5	      ;ECX => minutes
  push peax	      ;push minutes

  mov eax,ecx	      ;result of FormatTime
  and eax,0x1F	      ;EAX => hours
  push peax	      ;push hours

  mov eax,edx	      ;result of FormatDate
  and eax,0x1F	      ;EDX => day
  push peax	      ;push day

  mov eax,edx	      ;result of FormatDate
  and eax,0x1E0       ;ECX => month>5
  shr eax,5	      ;ECX => month
  push peax	      ;push month

  mov eax,edx	      ;result of FormatDate
  and eax,0xFFFFFE00  ;EAX => year>9
  shr eax,9	      ;EAX => year
  push peax	      ;push year
  call [FormatDateTime]

call dleave
if used is64
  ret psize*2
else
  ret psize*3
end if

errconvertDateTimeStringToLargeInteger:
if used is64
  add pesp,psize*3	  ;clear return pointer and argument from stack
  jmp pdword [pesp-psize] ;jump to error return pointer
else
  add pesp,psize*4	  ;clear return pointer and argument from stack
  jmp pdword [pesp-psize] ;jump to error return pointer
end if

;------------------------------------------------------------------------------
;This function will find the protocols in member optionsQuestionmarkStringIndexedCollection from structure HTTPSession that start by with string str
;input:
;    1:protocolsession
;    2:listensession
;    3:protocolsession to send settings from
;    4:listensession (can be zero) to send settings from
;    5:flags that have to meet the type member of InternalProtocolStructure
;    6:flags:
;       0x0 USE_DEFAULT_VALUE: fill in the default value
;       0x1 USE_CURRENT_SETTINGS: fill in the current settings, gathered from the protocolsession (&listensession)
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x4 LIST_ELEMENT_READABLE: Lists should be represented as readonly elements
;      reserved: 0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;      reserved: 0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;      0x20 LIST_SHOW_EMPTY_ELEMENTS there should be an empty field to be able to create a new line
;output:
;    (R/E)AX: none
;------------------------------------------------------------------------------
sendProtocolSettings:
call denter

mov peax,pdword [pebp+psize*5] ;listensession (can be zero) to send settings from
test peax,peax
jz noActiveListenSession

  or dword [pebp+psize*7], IS_ACTIVE_LISTENSESSION  ;set flag IS_ACTIVE_LISTENSESSION

noActiveListenSession:
sub pesp,(AMMOUNT_OF_TAGS*psize)+24+(2*psize) ;create an array with pointer to replace tags with  + 1 temp strings + 2 temp pointers

;zero structure with pointers for tags
mov ecx,AMMOUNT_OF_TAGS+(24/psize)+2
mov pedi,pesp
xor eax,eax
rep stosp

mov pesi,pdword [pebp+psize*4] ;protocolsession to send settings from

lea pedi,pdword [pesp+psize*AMMOUNT_OF_TAGS] ;get pointer to first temp string

push 10 		 ;base at 10
push pedi		 ;output string
push pesi		 ;protocol session
call IntToStr
mov [pesp+psize],pedi ;set %id_of_value%

;get the internal protocol structure
push pesi ;protocolsession
call GetInternalProtocolStructure
mov pesi,peax ;(R/E)SI => InternalProtocolSession
test pesi,pesi
jz endSendProtocolSettings

push peax
call getProtocolVisibleName
mov [pesp],peax ;set %name_of_value%

push pesp		   ;tag list
push 3			   ;stop at tag %value%
push pdword [parsed_elements+(group_index*psize)] ;pointer to parsed string
push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

mov pesi,pdword [pesi+psize*6] ;subOptions
test pesi,pesi
jz endLoopThroughSuboptions

mov edx,dword [pebp+psize*6] ;flags to be meet

;(R/E)SI => subOptions (ControlPanelOption struct)
;edx => flags parameter
;(R/E)sp => pointer to tag list
loopThroughSuboptions:
  test edx,edx
  jz noFlagsToMeet

  ;do one of the flags meet
  mov ecx,dword [pesi+psize+4] ;ECX => flags of subOption
  test ecx,edx
  jz nextLoopThroughSuboptions

  ;check if there is a userValue structure, if not, we cannot send this option
  mov pedi,pdword [pesi+psize+8+psize*7] ;userValue
  test pedi,pedi
  jz nextLoopThroughSuboptions

noFlagsToMeet:
  mov pebx,pdword [pedi+8] ;(R/E)BX => defaultValue

  mov eax,dword [pedi] ;type
  sub eax,2 ;TD_ASCII_STRING & TD_UNICODE_STRING
  jc noPointerRequierd

  if used is64
    sub eax,8 ;TD_BOOLEAN, TD_CHAR, TD_SHORT_INT, TD_INTEGER, TD_LARGE_INTEGER, TD_DATE, TD_TIME & TD_DATETIME
    jz noPointerRequierd ;TD_PROGRESS

    ;...TD_LIST
  else
    sub eax,4 ;TD_BOOLEAN, TD_CHAR, TD_SHORT_INT, TD_INTEGER
    jc getPointerToValue
    jz noPointerRequierd ;TD_LARGE_INTEGER

    sub eax,3  ;TD_DATE & TD_TIME
    jc getPointerToValue
    jz noPointerRequierd ;TD_DATETIME

    dec eax ;TD_PROGRESS
    jz noPointerRequierd ;TD_PROGRESS

     ;...TD_LIST
  end if

getPointerToList:
  mov peax,pdword [pedi+8] ;(R/E)AX => pointer to defaultValue
  mov pdword [pesp+(AMMOUNT_OF_TAGS*psize)+24],peax ;set first pointer with MultiColumnList
  mov pdword [pesp+(AMMOUNT_OF_TAGS*psize)+24+psize],0 ;zero second pointer

  lea pebx,pdword [pesp+(AMMOUNT_OF_TAGS*psize)+24] ;(R/E)BX => get pointer to 2 temp pointers


  jmp noPointerRequierd

getPointerToValue:
  lea pebx,pdword [pedi+8] ;(R/E)BX => pointer to defaultValue

noPointerRequierd:
  test dword [pebp+psize*7],USE_CURRENT_SETTINGS
  jz useDefaultValue

    mov ebx,ecx 				 ;ebx => flags for GetPluginData
    and ebx,GDPD_NAME_IS_INTEGER		 ;add flag GDPD_NAME_IS_INTEGER if set for this subOption

    cmp dword [pedi],TD_LIST			 ;is this type a list?
    jne dontAddListFlags

      or ebx,GDPD_IS_LIST or GDPD_NO_COPY_LIST	 ;add flags for list
      mov eax,psize*2				 ;two pointers
      jmp sizeToAllocateItOk

    dontAddListFlags:
    push 0 ;output size
    mov peax,pesp

    ;get size of the item
    push pebx		       ;flags
    push peax		       ;*size
    push 0		       ;*data
    push pdword [pesi+psize+8] ;*name
    push 0		       ;sess
    push pdword [pebp+psize*5] ;lsess
    push pdword [pebp+psize*4] ;psess
    call [GetPluginData]

    pop peax ;size to allocate
    test peax,peax
    jnz sizeToAllocateItOk

      mov eax,psize ;EAX = psize

    sizeToAllocateItOk:
    push peax ;*;en value

    push peax ;size
    call GetMemLocation ;allocate memory big enough to hold the value

    push pebx	  ;flags  (for GetPluginData)
    mov pebx,peax ;(R/E)BX => pointer to value
    lea peax,pdword [pesp+psize] ;*size


    ;get value
    ;push pebx                 ;flags (already done)
    push peax		       ;*size
    push pebx		       ;*data
    push pdword [pesi+psize+8] ;*name
    push 0		       ;sess
    push pdword [pebp+psize*5] ;lsess
    push pdword [pebp+psize*4] ;psess
    call [GetPluginData]

    add pesp,psize ;clear the *len value

    cmp dword [pedi],TD_LIST			 ;is this type a list?
    jne useDefaultValue

      ;set collection with rows on (R/E)BX + psize
      mov peax,pdword [pebx]
      mov pdword [pebx+psize],peax ;collection with rows

      ;set MultiColumnList on (R/E)BX
      mov peax,pdword [pedi+8] ;(R/E)AX => MultiColumnList
      mov pdword [pebx],peax ;(D/Q)Word [(R/E)BX] = MultiColumnList

useDefaultValue:
  mov eax,dword [pedi] ;type

  ;push for function
  push pdword [pebp+psize*4]	 ;psess (that the ControlPanelOption belongs to)
  push pdword [pebp+psize*7]	 ;flags
  push pecx			 ;flags (from ControlPanelOption)
  push pebx			 ;value
  push pdword [psize+pesi+8+psize] ;optionName
  push pdword [pesi+psize+8]	 ;*name
  push pdword [pebp+psize*3]	 ;sess
  push pdword [pebp+psize*2]	 ;psess
  push freeAllocatedValue	 ;set return pointer

  ;TD_ASCII_STRING
  test eax,eax
  jz sendASCIIString

  ;TD_UNICODE_STRING
  dec eax
  ;--jz sendUNICODEString

  ;TD_BOOLEAN
  dec eax
  jz sendBOOLEAN

  ;TD_CHAR
  dec eax
  jz sendChar

  ;TD_SHORT_INT
  dec eax
  jz sendShortInt

  ;TD_INTEGER
  dec eax
  jz sendInt

  ;TD_LARGE_INTEGER
  dec eax
  jz sendLargeInt

  ;TD_DATE
  dec eax
  jz sendDate

  ;TD_TIME
  dec eax
  jz sendTime

  ;TD_DATETIME
  dec eax
  jz sendDateTime

  ;TD_PROGRESS
  dec eax
  jz sendProgress

  ;;TD_LIST
  dec eax
  jz sendList

  add pesp,psize*9 ;clear pushed items

freeAllocatedValue:
  test dword [pebp+psize*7],USE_CURRENT_SETTINGS
  jz nextLoopThroughSuboptions

    ;cmp dword [pedi],TD_LIST                     ;is this type a list?
    ;jne doNotFreePointerInPointer

    ;  push pdword [pebx+psize] ;pointer to rows
    ;  call FreeMemLocation

doNotFreePointerInPointer:
    push pebx
    call FreeMemLocation

nextLoopThroughSuboptions:
  mov pesi,pdword [pesi] ;get next ControlPanelOption structure
  test pesi,pesi
jnz loopThroughSuboptions

endLoopThroughSuboptions:
push pesp		   ;tag list
push 0x3000000		   ;start at tag %value%
push pdword [parsed_elements+(group_index*psize)] ;pointer to parsed string
push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

endSendProtocolSettings:
call dleave
ret psize*6

;------------------------------------------------------------------------------
;This function will create a list of tags (all zero bytes) on stack
;input:
;    none
;output:
;    *R/E)SP => pointer to tags list  (and a string for inttostr on (R/E)SP + (AMMOUNT_OF_TAGS*psize) and one of (R/E)SP + (AMMOUNT_OF_TAGS*psize) + 24)
;corupts:
;       (R/E)AX,(R/E)DX,(R/E)CX, (R/E)DI
;------------------------------------------------------------------------------
createTagsListOnStack:
pop pedx

sub pesp,(AMMOUNT_OF_TAGS*psize)+24+24+24+24+24 ;create an array with pointer to replace tags with  and five temp strings

;zero structure with pointers for tags
mov ecx,AMMOUNT_OF_TAGS+(24/psize)+(24/psize)+(24/psize)+(24/psize)+(24/psize)
mov pedi,pesp
xor eax,eax
rep stosp

jmp pedx

;------------------------------------------------------------------------------
;This function will return the name of a value (and transfer an integer to string if neccesery)
;input:
;    1:psess (from ControlPanelOption structure)
;    2: name
;    3: flags
;output:
;    (R/E)AX => pointer to name (this pointer needs to be free'd by FreeMemLocation.)
;corupts:
;       none
;------------------------------------------------------------------------------
getIdOptionExternal:

push pdword [pesp+psize] ;push psess       (+1)
push 0					  ;(+2)
push pdword [pesp+psize*(3+2)] ;push flags (+3)
push 0					  ;(+4)
push 0					  ;(+5)
push pdword [pesp+psize*(2+5)] ;push name  (+6)
push 0					  ;(+7)
push 0					  ;(+8)
push 0					  ;(+9)
call denter

call createTagsListOnStack

call getIdOption

call dleave
add pesp,psize*9
ret psize*3

;------------------------------------------------------------------------------
;This function will return the name of a value (and transfer an integer to string if neccesery)
;input:
;    ebp+psize*4: name
;    ebp+psize*7: flags
;    pebp+psize*9:psess (from ControlPanelOption structure)
;    (R/E)SP+(AMMOUNT_OF_TAGS*psize): empty string
;output:
;    (R/E)AX => pointer to name (this pointer needs to be free'd by FreeMemLocation.)
;corupts:
;       (R/E)AX, (R/E)DI
;------------------------------------------------------------------------------
getIdOption:
push pesi  ;save (R/E)SI

mov edi,24+psize+psize ;add ann extra psize to ignore our return value and another to ignore the pushed (R/E)SI
call _getIdOption
mov pesi,peax ;(R/E)SI => id of the element
mov pedi,pdword [pebp+psize*9] ;psess (from ControlPanelOption structure)

call denter
;now add the protocolsession in front of the id

;length of the elementId
push pesi
call strlen
inc peax ;add a zero byte
mov pecx,peax ;ECX => size of elementId
add peax,24+1 ;add max size of a integer + '_' char

;get memory location for the new ID
push peax
call GetMemLocation
xchg pedi,peax ;exchange the memory location with the psess (from ControlPanelOption structure)

test peax,peax
cmovz pebx,pedi ;if(psess==0) (R/E)BX => pointer to mem location
jz noPsessToconvert ;do not copy the ProtocolSession

  push pecx ;save size of elementId
  push pesi ;save id of the element

  mov pebx,10
  mov pesi,pedi ;backup pointer to mem location
  call internalIntToStr

  ;copy a '_' char to separate the psess and elementId
  mov byte [pedi],'_'
  inc pedi

  mov pebx,pesi ;backup pointer to mem location

  pop pesi ;restore id of the element
  pop pecx ;restore size of elementId


noPsessToconvert:

rep movsb ;copy elementId

mov peax,pebx ;return the psess with elementId string

call dleave
pop pesi
ret


;------------------------------------------------------------------------------
;This function will return the optionname of a value (and transfer an integer to string if neccesery)
;input:
;    ebp+psize*4: name
;    ebp+psize*5: optionName
;    ebp+psize*7: flags (Control Panel)
;    (R/E)SP+(AMMOUNT_OF_TAGS*psize): empty string
;output:
;    (R/E)AX => pointer to name
;corupts:
;       (R/E)AX, (R/E)DI
;------------------------------------------------------------------------------
getNameOfOption:
xor eax,eax

mov peax,pdword [pebp+psize*5];optionName
test peax,peax
jnz endGetNameOfOption
xor edi,edi

_getIdOption:
mov peax,pdword [pebp+psize*4] ;name
test dword [pebp+psize*7],GDPD_NAME_IS_INTEGER
jz endGetNameOfOption

lea pedi,pdword [pesp+psize+psize*AMMOUNT_OF_TAGS+pedi] ;get pointer to first temp string

push 10 		  ;base at 10
push pedi		  ;output string
push peax		  ;option name
call IntToStr

mov peax,pedi

endGetNameOfOption:
ret

;------------------------------------------------------------------------------
;This function will send a list in it's right element
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags (from ControlPanelOption structure)
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x4 LIST_ELEMENT_READABLE: Lists should be represented as readonly elements
;      0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;      0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;      0x20 LIST_SHOW_EMPTY_ELEMENTS there should be an empty field to be able to create a new line
;    8:psess (that the ControlPanelOption belongs to)

;output:
;    none
;------------------------------------------------------------------------------
sendList:
call denter


call createTagsListOnStack

lea pesi,pdword [pesp+psize*AMMOUNT_OF_TAGS] ;get pointer to first temp string

mov pedi,pdword [pebp+psize*4] ;name
test dword [pebp+psize*7],GDPD_NAME_IS_INTEGER
cmovz pesi,pedi ;(R/E)SI => name
jz nameIsString

push 10 	      ;base = 10
push pesi	      ;output string
push pedi	      ;name
call IntToStr

nameIsString:
;count size of name
push pesi
call strlen
mov ecx,eax ;ECX = size of name
add peax,4+1 ;add string 'str_' or 'num_' and a zero byte

push peax
call GetMemLocation
mov pedi,peax  ;(R/E)DI => pointer to new %id_of_value%
mov pdword [pesp+psize],pedi ;set %id_of_value%  => "str_" or "num_" + name
mov pdword [pebp+psize*4],pedi ;set name

mov eax,'str_'
mov edx,'num_'

test dword [pebp+psize*7],GDPD_NAME_IS_INTEGER
cmovnz eax,edx
stosd;copy 'str_' or 'num_'

rep movsb ;copy name

idIsCreated:

test dword [pebp+psize*7],GDPD_NAME_IS_INTEGER
jz nameIsNotInteger

  ;delete the integer flag, since we changed the name by a string
  xor dword [pebp+psize*7],GDPD_NAME_IS_INTEGER

nameIsNotInteger:
lea pedi,pdword [pesp+psize*AMMOUNT_OF_TAGS] ;get pointer to first temp string
mov pdword [pesp+psize*27],pedi ;set %protocol_session%

mov ebx,10		;base = 10
;push pedi             ;output string
mov peax,pdword [pebp+psize*9]	   ;protocolsession
call internalIntToStr

call getNameOfOption
mov pdword [pesp],peax ;set %name_of_value%

;-call getIdOption
;-mov pdword [pesp+psize],peax ;set %id_of_value%

;-call decideReadOnlyOrWriteable
mov pecx,parsed_elements
mov pedx,parsed_elements_readonly
test dword [pebp+psize*8],LIST_SHOW_EMPTY_ELEMENTS
cmovnz peax,pecx
cmovz peax,pedx

mov pedi,pdword [peax+(TD_LIST*psize)] ;pointer to parsed string

mov pebx,pdword [pebp+psize*6] ;&value  (pointer to MultiColumnList, pointer to a pointer with rows collection)

loopListSend:
  push pesp		     ;tag list
  push 0x0C0E12 	     ;stop at tag %header%, %rows% & %empty_fields%
  push pedi		     ;pointer to parsed string
  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  call ParseAndSendByList

  mov pedi,pdword [pesp-3*psize] ;restore pointer to parsed string
  cmp byte[pedi],0
  jz endSendList  ;end if this is the end of the string

  ;push arguments for function sendHeaderList, sendRowsList or sendEmptyFieldsList
  push pdword [pebp+psize*9] ;psess (that the ControlPanelOption belongs to)
  push pdword [pebp+psize*8] ;flags

  push pdword [pebp+psize*7] ;flags (from ControlPanelOption structure)
  push pebx		     ;&value  (pointer to MultiColumnList, pointer to rows collection)
  push pdword [pebp+psize*5] ;optionName
  push pdword [pebp+psize*4] ;name
  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  push endSendListFunction ;retuirn address

  cmp byte [pedi],0x0C ;%header% tag
  je sendHeaderList

  cmp byte [pedi],0x0E ;%rows% tag
  je sendRowsList

  test dword [pebp+psize*8],LIST_SHOW_EMPTY_ELEMENTS
  jz dontShowEmptyFields

    cmp byte [pedi],0x12 ;%empty_fields% tag
    je SendEmptyFields

  dontShowEmptyFields:

  add pesp,psize*9   ;clear pushed arguments

endSendListFunction:
  inc pedi ;skip the tag index
  cmp byte[pedi],0
jne loopListSend

endSendList:
;free the id
push pdword [pesp+psize] ;%id_of_value% value
call FreeMemLocation

call dleave
ret psize*8

;------------------------------------------------------------------------------
;This function will send the header of a list
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:&value  (pointer to MultiColumnList, pointer to rows collection)
;    6:flags (from ControlPanelOption structure)
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x4 LIST_ELEMENT_READABLE: Lists should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
sendHeaderList:
call denter

call createTagsListOnStack

mov pesi,pdword [pebp+psize*6] ;(R/E)SI => &value  (pointer to MultiColumnList, pointer to rows collection)
mov pesi,pdword [pesi]	       ;(R/E)SI => pointer to MultiColumnList
if used is32
  lodsd      ;get size member
  add esi,4 ;skip flags member
else
  lodsq ;get size and flag member
end if

sub eax,SIZEOF_MULTICOLUNMLIST
jc endSendHeaderList ;jump if incorrect MultiColumnList size

cmp eax,SIZEOF_COLUMN
jc endSendHeaderList ;end if there is no UserValueOption

mov ecx,eax

loopColums:
  lodsp ;get pointer to optionName
  mov pdword [pesp+psize*2],peax ;set %value%


  push pesp		     ;tag list
  push 0		     ;no start or stop tag    '

  call decideReadOnlyOrWriteable
  push pdword [peax+(list_header_index*psize)] ;pointer to parsed string

  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  call ParseAndSendByList

  add pesi,SIZEOF_USERVALUEOPTION  ;skip the UserValueOption structure

  sub ecx,SIZEOF_COLUMN
ja loopColums


endSendHeaderList:
call dleave
ret psize*8

;------------------------------------------------------------------------------
;This function will send the rows of a list
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:MultiColumnList
;    6:flags (from ControlPanelOption structure)
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x4 LIST_ELEMENT_READABLE: Lists should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
sendRowsList:
call denter

call createTagsListOnStack

;-call getIdOption
;-mov pdword [pebp+psize*4],peax ;set name =protocolsession + "_"  + name of list

;-test dword [pebp+psize*7],GDPD_NAME_IS_INTEGER
;-jz nameIsNotInteger1

;-  ;delete the integer flag, since we changed the name by a string
;-  xor dword [pebp+psize*7],GDPD_NAME_IS_INTEGER

;-nameIsNotInteger1:

mov peax,pdword [pebp+psize*4] ;get pointer to name
mov pdword [pesp+psize],peax ;set %id_of_value% => protocolsession

lea pedi,pdword [pesp+psize*AMMOUNT_OF_TAGS+24+24] ;get pointer to third temp string
mov pdword [pesp+psize*27],pedi ;set %protocol_session% => protocolsession

push 10 		   ;base at 10
push pedi		   ;output string
push pdword [pebp+psize*9] ;ProtocolSession
call IntToStr

lea pedi,pdword [pesp+psize*AMMOUNT_OF_TAGS] ;get pointer to first temp string
mov pdword [pesp+psize*2],pedi ;set %value% => rowId

;make elements readonly if needed
call decideReadOnlyOrWriteableList ;(LIST_ELEMENT_READABLE)

mov pesi,pdword [pebp+psize*6] ;(R/E)SI => &value  (pointer to MultiColumnList, pointer to rows collection)
mov pesi,pdword [pesi]	       ;(R/E)SI => pointer to MultiColumnList

if used is64
  lodsd ;get size member MultiColumnList
  add pesi,4 ;skip size and flags
  sub eax,SIZEOF_MULTICOLUNMLIST
else
  mov ecx,dword [pesi] ;get size member MultiColumnList
  add pesi,8 ;skip size and flags
  sub ecx,SIZEOF_MULTICOLUNMLIST
end if

;Do a divide by the size of COLUMN strcuture to get the ammount of COLUMN structures
;multiply by the size of a integer to get the size needed for a structure with the types
if used is64
  ;divide by 24 (the size of the structure)
  xor edx,edx
  mov ecx,24
  div ecx

  mov ecx,eax ;ecx= ammount of COLUMN structures

  shl ecx,2 ;ecx=ecx*4 (the size of a dword)
else
  shr ecx,2 ;divide by 16 (the size of structure) AND multiply by 4 (a dword)
end if

push pecx
call GetMemLocation
mov pedi,peax ;pointer of temp structure with types of every item in a row

mov edx,ecx ;backup the size of the structure with types

;get the ammount of items in 1 row
if used is64
  shr ecx,2 ;divide by 4
else
  shr ecx,2 ;divide by 4
end if

push pedi ;save (R/E)DI)

;Fill in the types in the structure
fillInStructureWithType:
  lodsp ;skip optionName

  ;load type from rsi/esi and store in rdi/edi
  lodsd
  stosd

  ;skip the defaultValueSize and defaultValue member,
  ;  add pesi,psize+4, but this is smaller
  ;can replace this, but using lods is smaller
  lodsd
  lodsp
loopd fillInStructureWithType

pop pedi ;restore (R/E)DI)

;EDX = the size of the structure with types
;EDI = pointer to structure with the types

;--mov ebx,edx ;ebx =  the size of the structure with types
;get the ammount of items in 1 row
if used is64
  shr edx,2 ;divide by 4
else
  shr edx,2 ;divide by 4
end if

lodsp ;get the member rows
mov pesi,peax ;(R/E)SI => pointer to collection with rows

  mov peax,pdword [pebp+psize*6] ;(R/E)AX => &value  (pointer to MultiColumnList, pointer a rows collection)
  mov peax,pdword [peax+psize]	 ;(R/E)AX =>pointer a rows collection

test peax,peax
cmovnz pesi,peax

;get ammount of rows
push pesi
call [CountListRows]
mov ecx,eax ;ECX = ammount of rows
mov ebx,eax ;EBX = ammount of rows

test peax,peax
jz endLoopSendRows

;-ecx => position of current row
;-ebx => ammount of rows
;-edx = ammount of items/row
;-(R/E)SI = pointer to collection with rows
;-(R/E)DI = pointer to structure with the types
loopSendRows:

  ;-push pedi

  mov peax,pdword [pesp+psize*2] ;set %value% = rowId
  ;-mov pdword [pesp+psize*2],peax ;set %id_of_value%

  push 10		      ;base
  push peax		      ;output str
  ;name => rowId
  mov peax,pebx
  sub peax,pecx
  inc peax

  push peax		       ;rowId

  call IntToStr

  ;-pop pedi

  ;send element lsit_row until %row%
  push pesp		     ;tag list
  push 0x1B		     ;stop at tag %row%

  call decideReadOnlyOrWriteableList2
  push pdword [peax+(list_row_index*psize)] ;pointer to parsed string

  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  call ParseAndSendByList


  mov eax,ebx ;EAX => ammount of rows
  sub eax,ecx ;EAX -= current row
  inc eax     ;EAX++ sice the rows start at Id 1.

  push pecx ;save position of current row
  push pebx ;save ammount of rows
  xor ecx,ecx ;clear ECX
  mov pebx,peax ;save rowId

  loopRow:
    ;send element list_row_item until tag %value_element%
    lea peax,pdword [pesp+psize*2] ;get tag list  by skipping the pushed position of current row & ammount of rows
    push peax		       ;tag list
    push 0x0D		       ;end at tag at tag %value_element%

    call decideReadOnlyOrWriteableList2
    push pdword [peax+(list_row_item_index*psize)] ;pointer to parsed string

    push pdword [pebp+psize*3] ;lsess
    push pdword [pebp+psize*2] ;psess
    call ParseAndSendByList

    ;get size of item
    push pecx ;itemId
    push pebx ;rowId
    push pesi ;list
    call [GetListItemSize]
    test peax,peax
    jnz notZeroSize

      mov eax,4 ;a integer

    notZeroSize:
    push peax ;push *len parameter

    ;get memory location for the item
    push peax
    call GetMemLocation


    ;get item
    push pesp ;push *len (already done)
    push peax ;*data
    push pecx ;itemId
    push pebx ;rowId
    push pesi ;row
    call [GetListItem]

    mov peax,pdword [pesp-psize*2] ;restore data parameter

    add pesp,psize ;delete *len parameter


    ;push for FreeMemLocation
    push peax

    ;push for function
    push 0			   ;protocol session it belongs to
    push pdword [pebp+psize*8]	   ;flags
    or dword [pesp],USE_LIST_POS ;set flag no name
    push pdword [pebp+psize*7]	   ;flags (from ControlPanelOption)
    or dword [pesp],USE_LIST_POS
    push peax			   ;value
    push pdword [pebp+psize*5]	   ;optionName
    push pdword [pebp+psize*4]	   ;*name
    push pdword [pebp+psize*3]	   ;lsess
    push pdword [pebp+psize*2]	   ;psess
    push nextLoopRow		   ;set return pointer

    mov eax,ecx ;eax => itemId
    ;get position in structure with the types
    shl eax,2 ;multiply by 4
    mov eax,dword [pedi+peax] ;get type of current item

    ;TD_ASCII_STRING
    test eax,eax
    jz sendASCIIString

    ;TD_UNICODE_STRING
    dec eax
    ;--jz sendUNICODEString

    ;TD_BOOLEAN
    dec eax
    jz sendBOOLEAN

    ;TD_CHAR
    dec eax
    jz sendChar

    ;TD_SHORT_INT
    dec eax
    jz sendShortInt

    ;TD_INTEGER
    dec eax
    jz sendInt

    ;TD_LARGE_INTEGER
    dec eax
    jz sendLargeInt

    ;TD_DATE
    dec eax
    jz sendDate

    ;TD_TIME
    dec eax
    jz sendTime

    ;TD_DATETIME
    dec eax
    jz sendDateTime

    ;TD_PROGRESS
    dec eax
    jz sendProgress

    ;-;;TD_LIST
    ;-dec eax
    ;-jz sendList

;endsdfsdf:
    add pesp,psize*9 ;clear pushed items
  nextLoopRow:

    ;free value of this item
    ;push already done
    call FreeMemLocation

    ;send element list_row_item from %value_element%
    lea peax,pdword [pesp+psize*2] ;get tag list  by skipping the pushed position of current row & ammount of rows
    push peax		       ;tag list
    push 0x0D000000	       ;start at tag at tag %value_element%

    call decideReadOnlyOrWriteableList2
    push pdword [peax+(list_row_item_index*psize)] ;pointer to parsed string

    push pdword [pebp+psize*3] ;lsess
    push pdword [pebp+psize*2] ;psess
    call ParseAndSendByList

    inc ecx
    cmp ecx,edx
  jne loopRow ;jump if this not the last row item

  pop pebx ;restore ammount of rows
  pop pecx ;restore position of curren row

nextLoopSendRows:
  ;send element list_row from %row%
  push pesp		     ;tag list
  push 0x1B000000	     ;start at tag %row%

  call decideReadOnlyOrWriteableList2
  push pdword [peax+(list_row_index*psize)] ;pointer to parsed string

  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  call ParseAndSendByList

  ;-;free %id_of_value%
  ;-push pdword [pesp+psize]
  ;-call FreeMemLocation
  ;-mov pdword [pesp+psize],0

  dec ecx
jnz loopSendRows

endLoopSendRows:
;free pointer to structure with the types
push pedi
call FreeMemLocation

endSendRowsList:
;- ;free %id_of_value%
;- push pdword [pebp+psize*4]
;- call FreeMemLocation

call dleave
ret psize*8

;--------------------------------------------------------------------------------------------------------------------------------------------------------

;------------------------------------------------------------------------------
;This function will send the empty fields for a list to add a row
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:MultiColumnList
;    6:flags (from ControlPanelOption structure)
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x4 LIST_ELEMENT_READABLE: Lists should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
SendEmptyFields:
call denter

call createTagsListOnStack

mov pesi,pdword [pebp+psize*4] ;name

;count the size of the name
push pesi
call strlen
mov pecx,peax ;ECX = size of name
add peax,24 ;add size for a counter + '_' + zero byte

push peax
call GetMemLocation
mov pdword [pebp+psize*4],peax
mov pedi,peax

rep movsb ;copy the name

mov al,'_'
stosb

mov pdword [pesp],pedi ;save position of the empty part for a integer to string conversion


mov pesi,pdword [pebp+psize*6] ;(R/E)SI => &value  (pointer to MultiColumnList, pointer to rows collection)
mov pesi,pdword [pesi]	       ;(R/E)SI => pointer to MultiColumnList

if used is64
  lodsd ;get size member MultiColumnList
  add pesi,4 ;skip size and flags
  sub eax,SIZEOF_MULTICOLUNMLIST
else
  mov ecx,dword [pesi] ;get size member MultiColumnList
  add pesi,8 ;skip size and flags
  sub ecx,SIZEOF_MULTICOLUNMLIST
end if


;Do a divide by the size of COLUMN strcuture to get the ammount of COLUMN structures
;multiply by the size of a integer to get the size needed for a structure with the types
if used is64
  ;divide by 24 (the size of the structure)
  xor edx,edx
  mov ecx,24
  div ecx

  mov ecx,eax ;ecx= ammount of COLUMN structures
else
  shr ecx,4 ;divide by 16 (the size of structure)(ECX = ammount of
end if

xor edx,edx

;Fill in the types in the structure
loopThroughColumns:
  mov eax,dword [pesi+psize]	     ;EAX = type
  mov pebx,pdword [pesi+psize+8] ;(R/E)BX => defaultValue

  sub eax,2 ;TD_ASCII_STRING & TD_UNICODE_STRING
  jc noPointerRequierd1

  if used is64
    sub eax,8 ;TD_BOOLEAN, TD_CHAR, TD_SHORT_INT, TD_INTEGER, TD_LARGE_INTEGER, TD_DATE, TD_TIME & TD_DATETIME
    jz noPointerRequierd1 ;TD_PROGRESS

    ;...TD_LIST
  else
    sub eax,4 ;TD_BOOLEAN, TD_CHAR, TD_SHORT_INT, TD_INTEGER
    jc getPointerToValue1
    jz noPointerRequierd1 ;TD_LARGE_INTEGER

    sub eax,3  ;TD_DATE & TD_TIME
    jc getPointerToValue1
    jz noPointerRequierd1 ;TD_DATETIME

    dec eax ;TD_PROGRESS
    jz noPointerRequierd1 ;TD_PROGRESS

     ;...TD_LIST
  end if

getPointerToValue1:
  lea pebx,pdword [pesi+psize+8] ;(R/E)BX => pointer to defaultValue

noPointerRequierd1:
  ;convert the column_id to string in the name paramter
  push 10
  push pdword [pesp+psize] ;output string
  push pedx			 ;column_id
  inc pdword [pesp]		 ; increment column_id (so column 0 = 1 )
  call IntToStr

  ;push for function
  push 0			 ;psess
  push pdword [pebp+psize*8]	 ;flags
  push pdword [pebp+psize*7]	 ;flags (from ControlPanelOption)
  push pebx			 ;value
  push pdword [pesi]		 ;optionName
  push pdword [pebp+psize*4]	 ;*name
  push pdword [pebp+psize*3]	 ;lsess
  push pdword [pebp+psize*2]	 ;psess
  push nextLoopThroughColumns	 ;set return pointer

  mov eax,dword [pesi+psize]	 ;EAX = type

  ;TD_ASCII_STRING
  test eax,eax
  jz sendASCIIString

  ;TD_UNICODE_STRING
  dec eax
  ;--jz sendUNICODEString

  ;TD_BOOLEAN
  dec eax
  jz sendBOOLEAN

  ;TD_CHAR
  dec eax
  jz sendChar

  ;TD_SHORT_INT
  dec eax
  jz sendShortInt

  ;TD_INTEGER
  dec eax
  jz sendInt

  ;TD_LARGE_INTEGER
  dec eax
  jz sendLargeInt

  ;TD_DATE
  dec eax
  jz sendDate

  ;TD_TIME
  dec eax
  jz sendTime

  ;TD_DATETIME
  dec eax
  jz sendDateTime

  ;TD_PROGRESS
  dec eax
  jz sendProgress

  ;--;;TD_LIST
  ;--dec eax
  ;--jz sendList

  add pesp,psize*9 ;clear pushed items


nextLoopThroughColumns:
  inc edx
  ;skip to the next column structure
  add pesi,SIZEOF_COLUMN
  dec pecx
jnz loopThroughColumns

endSendEmptyFields:
;free name
push pdword [pesp]
call FreeMemLocation

call dleave
ret psize*8


;--------------------------------------------------------------------------------------------------------------------------------------------------------


;------------------------------------------------------------------------------
;This function will send a progess/slidebar in it's right element
;input:
;    1:psess
;    2:sess
;    3:name
;    4:optionName
;    5:value
;    6:flags (from ControlPanelOption structure)
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)

;output:
;    none
;------------------------------------------------------------------------------
sendProgress:
call denter

call createTagsListOnStack

call getNameOfOption
mov pdword [pesp],peax ;set %name_of_value%

call getIdOption
mov pdword [pesp+psize],peax ;set %id_of_value%

mov pesi,pdword [pebp+psize*6] ;value
lea pedi,pdword [pesp+(psize*AMMOUNT_OF_TAGS)+24+24] ;get pointer to third temp string

mov pdword [pesp+psize*14],pedi ;set %value_pos%
lodsd ;get curPos
mov ebx,10 ;base
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*16],pedi ;set %value_min%
lodsd ;get minimum
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*15],pedi ;set %value_max%
lodsd ;get maximum
call internalIntToStr


push pesp		   ;tag list
push 0			   ;no start or stop tag    '

call decideReadOnlyOrWriteable
push pdword [peax+(TD_PROGRESS*psize)] ;pointer to parsed string

push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

;free the id
push pdword [pesp+psize] ;%id_of_value% value
call FreeMemLocation

call dleave
ret psize*8

;------------------------------------------------------------------------------
;This function will send a date and or time in it's right element
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
sendDateTime:
call denter
sub pesp,0x18 ;DATETIME structure
mov pesi,pesp ;(R/E)SI => TIMEDATE structure

mov peax,pdword [pebp+psize*6] ;value

push pesi     ;TIMEDATE structure
if used is64
  push qword [peax] ;datetime long long (x64)
else
  push peax ;datetime pointer to long long (x86)
end if
call [RecoverDateTime]

call decideReadOnlyOrWriteable
mov pebx,pdword [peax+(TD_DATETIME*psize)] ;(R/E)BX => pointer to parsed string
jmp sendDATETIMEstruct

;send time
sendTime:
call denter
sub pesp,0x18 ;DATETIME structure
mov pesi,pesp ;(R/E)SI => TIMEDATE structure

mov peax,pdword [pebp+psize*6] ;value
mov eax,dword [peax] ;time integer

push pesi     ;TIMEDATE structure
push peax     ;time integer
call [RecoverTime]

call decideReadOnlyOrWriteable
mov pebx,pdword [peax+(TD_TIME*psize)] ;(R/E)BX => pointer to parsed string
jmp sendDATETIMEstruct

;send date
sendDate:
call denter
sub pesp,0x18 ;DATETIME structure
mov pesi,pesp ;(R/E)SI => TIMEDATE structure

mov peax,pdword [pebp+psize*6] ;value
mov eax,dword [peax] ;date integer

push pesi     ;TIMEDATE structure
push peax     ;date integer
call [RecoverDate]

call decideReadOnlyOrWriteable
mov pebx,pdword [peax+(TD_DATE*psize)] ;(R/E)BX => pointer to parsed string
;jmp sendDATETIMEstruct

sendDATETIMEstruct:
call createTagsListOnStack

call getNameOfOption
mov pdword [pesp],peax ;set %name_of_value%

call getIdOption
mov pdword [pesp+psize],peax ;set %id_of_value%

if used is32
  mov dword [esp+psize*3],ebx ;save pointer to parsed string on %value:true%...% (since it is not used at all...)
else
  mov r12,rbx ;R12 => pointer to parsed string
end if

lea pedi,pdword [pesp+(psize*AMMOUNT_OF_TAGS)+24+24] ;get pointer to third temp string

mov pdword [pesp+psize*5],pedi ;set %value_yyyy%`
lodsd ;get year
mov ebx,10 ;base
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*6],pedi ;set %value_month%
xor eax,eax ;zero eax
lodsw ;get month
call addZeroByteIfZero
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*7],pedi ;set %value_dd%
lodsw ;get dayOfTheWeek
lodsw ;get day
call addZeroByteIfZero
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*8],pedi ;set %value_hh%
lodsw ;get hours
call addZeroByteIfZero
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*9],pedi ;set %value_mm%
lodsw ;get minutes
call addZeroByteIfZero
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*10],pedi ;set %value_ss%
lodsw ;get seconds
call addZeroByteIfZero
call internalIntToStr

xor al,al
stosb

mov pdword [pesp+psize*25],pedi ;set %value_ms%
lodsw ;get milliseconds
call internalIntToStr

xor al,al
stosb

if used is32
  mov ebx,dword [esp+psize*3] ;restore pointer of parsed string from %value:true%...% (since it is not used at all...)
  mov dword [esp+psize*3],0   ;zero %value:true%...%
end if

push pesp		   ;tag list
push 0			   ;no start or stop tag
if used is32
  push pebx		     ;pointer to parsed string
else
  push r12
end if
push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

endSendDate:
;free the id
push pdword [pesp+psize] ;%id_of_value% value
call FreeMemLocation

call dleave
ret psize*8

;------------------------------------------------------------------------------
;This function will add char '0' if al<10
;input:
;    al: number
;    (R/E)DI: pointer to string to add the zero char
;output:
;    none
;------------------------------------------------------------------------------
addZeroByteIfZero:
cmp al,10
jnc endAddZeroByteIfZero

push peax
mov al,'0'
stosb
pop peax

endAddZeroByteIfZero:
ret

;------------------------------------------------------------------------------
;This function will return a pointer to parsed_elements if writeable and a pointer to  parsed_elements_readonly if readonly
;This function deffers from decideReadOnlyOrWriteable that this also effects the flag LIST_ELEMENT_READABLE
;input:
;    pebp+psize*7: flags from ControlPanelOption
;    pebp+psize*8: flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x4 LIST_ELEMENT_READABLE: Lists should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;output:
;    (R/E)AX => pointer to parsed_elements or parsed_elements_readonly
;------------------------------------------------------------------------------
decideReadOnlyOrWriteableList2:
push pedx

mov peax,parsed_elements
mov pedx,parsed_elements_readonly
test dword [pebp+psize*8],LIST_SHOW_EMPTY_ELEMENTS
cmovz peax,pedx

pop pedx
ret


;------------------------------------------------------------------------------
;This function will return a pointer to parsed_elements if writeable and a pointer to  parsed_elements_readonly if readonly
;This function deffers from decideReadOnlyOrWriteable that this also effects the flag LIST_ELEMENT_READABLE
;input:
;    pebp+psize*7: flags from ControlPanelOption
;    pebp+psize*8: flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x4 LIST_ELEMENT_READABLE: Lists should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;output:
;    (R/E)AX => pointer to parsed_elements or parsed_elements_readonly
;------------------------------------------------------------------------------
decideReadOnlyOrWriteableList:
test pdword [pebp+psize*8],LIST_ELEMENT_READABLE
jz decideReadOnlyOrWriteable

or pdword [pebp+psize*8],READABLE_ELEMENT ;set flag READABLE_ELEMENT if flag LIST_ELEMENT_READABLE is set
;jmp decideReadOnlyOrWriteable

;------------------------------------------------------------------------------
;This function will return a pointer to parsed_elements if writeable and a pointer to  parsed_elements_readonly if readonly
;input:
;    pebp+psize*7: flags from ControlPanelOption
;    pebp+psize*8: flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;output:
;    (R/E)AX => pointer to parsed_elements or parsed_elements_readonly
;------------------------------------------------------------------------------
decideReadOnlyOrWriteable:
push pecx

mov peax,parsed_elements
mov pecx,parsed_elements_readonly
;check controlpanel flag on readonly
test pdword [pebp+psize*7],CPO_GEN_READONLY
cmovnz peax,pecx
jnz choosenReadonly

;check flag on readonly
test pdword [pebp+psize*8],READABLE_ELEMENT
cmovnz peax,pecx
jnz choosenReadonly

;check if this are options fron an active listensession
test pdword [pebp+psize*8],IS_ACTIVE_LISTENSESSION
jz choosenReadonly ;jump if not

;check flag on readonly
test pdword [pebp+psize*7],CPO_GEN_LISTENSESSION_READONLY
cmovnz peax,pecx
;-jnz choosenReadonly

choosenReadonly:
pop pecx

test pdword [pebp+psize*8],USE_LIST_POS
jz endDecideReadOnlyOrWriteable

add peax,pos_list_index

endDecideReadOnlyOrWriteable:
ret

;------------------------------------------------------------------------------
;This function will send a string with element index EBX, denter should have been called already
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:value

;output:
;    value
;------------------------------------------------------------------------------
sendHiddenField:
call denter

call createTagsListOnStack

mov peax,pdword [pebp+psize*4] ;name
mov pdword [pesp+psize],peax ;set %id_of_value%

mov pebx,pdword [pebp+psize*5] ;value
mov pdword [pesp+psize*2],pebx ;set %value%

push pesp		   ;tag list
push 0			   ;no start or stop tag
push pdword [parsed_elements+(hidden_fields_index*psize)] ;pointer to parsed string
push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

mov peax,pebx ;(R/E)AX => value

call dleave
ret psize*4

;------------------------------------------------------------------------------
;This function will send a boolean in it's right element
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
sendBOOLEAN:
call denter

call createTagsListOnStack

call getNameOfOption
mov pdword [pesp],peax ;set %name_of_value%

call getIdOption
mov pdword [pesp+psize],peax ;set %id_of_value%

mov peax,pdword [pebp+psize*6] ;&value
mov peax,pdword [peax]	       ;value
mov ecx,4
mov edx,5

test peax,peax
cmovnz edx,ecx ;EDX = 5(tag index of "%value:false%") if boolean is false
	       ;EDX = 5(tag index of "%value:true%") if boolean is true

call decideReadOnlyOrWriteable
mov pedi,pdword [peax+(TD_BOOLEAN*psize)] ;pointer to parsed string

loopBooleanReplacement:
  push pesp		     ;tag list
  push 0x0405		     ;stop processing at %value:true% and %value:false%
  push pedi		     ;pointer to parsed string
  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  call ParseAndSendByList

  mov pedi,pdword [pesp-3*psize] ;restore pointer to parsed string
  cmp byte[pedi],0
  jz endSendBOOLEAN  ;end if this is the end of the string

  push pedi
  call strlen
  mov ecx,eax	;ECX = length of string
  mov ebx,eax	;EBX = length of string
  mov pesi,pedi ;(R/E)SI => copy of poitner to parsed string
  mov al,'%'
  repnz scasb ;search for '%'
  jnz endSendBOOLEAN ;reached end of string

  cmp byte [pesi],dl ;check if the tag is true or false
  jne loopBooleanReplacement

  xchg ecx,ebx
  sub ecx,ebx
  inc pesi  ;skip index tag
  sub ecx,2 ;substract the index tag and substract the ending %
  call shortSendData ;send (R/E)SI with size ECX
jmp loopBooleanReplacement


endSendBOOLEAN:
;free the id
push pdword [pesp+psize] ;%id_of_value% value
call FreeMemLocation

call dleave
ret psize*8


;------------------------------------------------------------------------------
;This function will send a large integer on x86 in there right element
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
if used is32
sendLargeInt:
call denter

call createTagsListOnStack

call getNameOfOption
mov pdword [pesp],peax ;set %name_of_value%

call getIdOption
mov pdword [pesp+psize],peax ;set %id_of_value%

mov peax,pdword [pebp+psize*6] ;value
lea pedi,pdword [pesp+(psize*AMMOUNT_OF_TAGS)+24+24] ;get pointer to third temp string

;convert value integer to string
push 10 		  ;base at 10
push pedi		  ;output string
push peax		  ;value  (Qword)
call IntQToStr
mov pdword [pesp+psize*2],pedi ;set %value%

push pesp		   ;tag list
push 0			   ;no start or stop tag

call decideReadOnlyOrWriteable
push pdword [peax+(TD_LARGE_INTEGER*psize)] ;pointer to parsed string

push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

;free the id
push pdword [pesp+psize] ;%id_of_value% value
call FreeMemLocation

call dleave
ret psize*8
end if

;------------------------------------------------------------------------------
;This function will send a integer in there right element
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
if used is64
  sendLargeInt:
  call denter
  mov pebx,TD_LARGE_INTEGER
  jmp sendIntegerWithElement
end if

sendInt:
call denter
mov pebx,TD_INTEGER
jmp sendIntegerWithElement

sendShortInt:
call denter
mov pebx,TD_SHORT_INT
;jmp sendIntegerWithElement

sendIntegerWithElement:
call createTagsListOnStack

call getNameOfOption
mov pdword [pesp],peax ;set %name_of_value%

call getIdOption
mov pdword [pesp+psize],peax ;set %id_of_value%

mov peax,pdword [pebp+psize*6] ;value
lea pedi,pdword [pesp+(psize*AMMOUNT_OF_TAGS)+24+24] ;get pointer to third temp string

;convert value integer to string
push 10 		  ;base at 10
push pedi		  ;output string
push pdword [peax]	  ;value
call IntToStr
mov pdword [pesp+psize*2],pedi ;set %value%

push pesp		   ;tag list
push 0			   ;no start or stop tag

call decideReadOnlyOrWriteable
push pdword [peax+(pebx*psize)] ;pointer to parsed string


push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

;free the id
push pdword [pesp+psize] ;%id_of_value% value
call FreeMemLocation

call dleave
ret psize*8


;------------------------------------------------------------------------------
;This function will send a char in there right element
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
sendChar:
call denter

mov pebx,TD_CHAR
jmp sendStringPointer

;------------------------------------------------------------------------------
;This function will send a ASCII string in there right element
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)
;output:
;    none
;------------------------------------------------------------------------------
sendASCIIString:
call denter

mov pebx,TD_ASCII_STRING
;jmp sendStringPointer

;------------------------------------------------------------------------------
;This function will send a string with element index EBX, denter should have been called already
;input:
;    1:psess
;    2:lsess
;    3:name
;    4:optionName
;    5:value
;    6:flags
;    7:flags:
;       0x0 WRITEABLE_ELEMENT: The options of this protocol should be represented as editable elements
;       0x2 READABLE_ELEMENT: The options of this protocol should be represented as readonly elements
;       0x8 USE_LIST_POS: (set parsed_elements on parsed_elements_readonly on +USE_LIST_POS)
;       0x10 IS_ACTIVE_LISTENSESSION: The options are from an active Listensession and therefore flag CPO_GEN_LISTENSESSION_READONLY sahould be taken seriously.
;    8:psess (that the ControlPanelOption belongs to)

;EBX => index of element
;output:
;    none
;------------------------------------------------------------------------------
sendStringPointer:

call createTagsListOnStack

call getNameOfOption
mov pdword [pesp],peax ;set %name_of_value%

call getIdOption
mov pdword [pesp+psize],peax ;set %id_of_value%

mov peax,pdword [pebp+psize*6] ;value
mov pdword [pesp+psize*2],peax ;set %value%

push pesp		   ;tag list
push 0			   ;no start or stop tag

call decideReadOnlyOrWriteable
push pdword [peax+(pebx*psize)] ;pointer to parsed string


push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call ParseAndSendByList

;free the id
push pdword [pesp+psize] ;%id_of_value% value
call FreeMemLocation

call dleave
ret psize*8



;------------------------------------------------------------------------------
;This function will find the string optionname+0..511  in member optionsQuestionmarkStringIndexedCollection from structure HTTPSession, convert the values to integers and put them in a buffer
;input:
;    1:psess (ignored if flag SEND_AS_HIDDEN_FIELDS is not set)
;    2:sess (ignored if flag SEND_AS_HIDDEN_FIELDS is not set)
;    3:HTTPSession
;    4:optionname
;    5:flags
;      0x1 SEND_AS_HIDDEN_FIELDS send the found fields back as hidden_fields
;output:
;    (R/E)AX: a pointer to:
;               count:[4/8] bytes: count of protocolsessions
;               protocolsessions[count]
;------------------------------------------------------------------------------
collectIntegersByEnumerationName:
call denter

mov pesi,pdword [pebp+psize*5] ;(R/E)SI => option name

;calculates the size of option name
push pesi
call strlen
mov ecx,eax ;ECX = size of option name
inc ecx

;round up by 4
shr eax,1
adc eax,0 ;round up by 2
shr eax,1
adc eax,0 ;round up by 4
if used is64
  shr eax,1
  adc eax,0 ;round up by 8
  shl eax,3 ;get the original value round up by 8
else
  shl eax,2 ;get the original value round up by 4
end if

add eax,24 ;add space for int to string conversion
sub pesp,peax ;create space on stack for the new string

mov pedi,pesp ;(R/E)DI => option name
rep movsb ;copy the option name to the buffer

mov pesi,pedi ;(R/E)DX => end of option name (where we should execute function IntToStr on '
dec pesi
mov pedx,pesp ;(R/E)DX => begin of option name

push 512*psize ;place for 511 protocolsessions and count value
call GetMemLocation
mov pedi,peax  ;(R/E)DI => pointer to output buffer
add pedi,psize ;skip the counter

mov ecx,511 ;set maximum ammount of allowed protocolsessions

mov pebx,pdword [pebp+psize*4] ;(R/E)BX => HTTPSession
mov pebx,pdword [pebx+psize*2] ;(R/E)BX => optionsQuestionmarkStringIndexedCollection

getProtocolSessionsFromURL:
  lea peax,pdword [pecx-511]  ;pecx-511 => -the current number
  neg peax		      ;-(pecx-511) => the current number
  jz dontCovertNumber

    push 10   ;base
    push pesi ;output string
    push peax ;number to convert to ASCII string
    call IntToStr

  dontCovertNumber:
  ;get optionname + inttostr(i)
  push pedx
  push pebx ;optionsQuestionmarkStringIndexedCollection
  call [GetCollectionItem]
  test peax,peax
  jz endGetProtocolSessionsFromURL ;no more found, end this function

  test dword [pebp+psize*6],SEND_AS_HIDDEN_FIELDS
  jz doNotSendHiddenFields

    push peax		       ;value
    push pedx		       ;name
    push pdword [pebp+psize*3] ;sess
    push pdword [pebp+psize*2] ;psess
    call sendHiddenField

  doNotSendHiddenFields:

  push 10
  push peax  ;string
  call StrToInt ;convert the protocolsession to a integer
  test peax,peax
  jz endGetProtocolSessionsFromURL

  stosp 	;store the integer into the buffer
loop getProtocolSessionsFromURL

endGetProtocolSessionsFromURL:
lea peax,pdword [pecx-512]  ;pecx-511 => -(ammount of found protocolsessions + counter)
neg peax		    ;-(pecx-511) => ammount of found protocolsessions + counter

if used is32
  lea ecx,dword [eax*4] ;ecx => (ammount of found protocolsessions+ counter) * psize
else
  lea ecx,dword [eax*8] ;ecx => (ammount of found protocolsessions+ counter) * psize
end if

sub pedi,pecx ;(R/E)DI => begin from the buffer  with protocolsession
dec peax      ;delete teh counter from teh counter itself
mov pdword [pedi],peax ;set counter
mov peax,pedi ;(R/E)AX => begin from the buffer  with protocolsession

call dleave
ret psize*5

;------------------------------------------------------------------------------
;This function will return InternalProtocolStructure->main->optionName if exist,
;else it will return InternalProtocolStructure->psess->protocolName (which always exist)
;input:
;    1:InternalProtocolStructure
;output:
;    (R/E)AX => pointer to a zero terminating string with the name of the protocol
;------------------------------------------------------------------------------
getProtocolVisibleName:
call denter

mov pesi,pdword [pebp+psize*2] ;(R/E)SI => InternalProtocolStructure
mov pedi,pdword [pesi+psize*2] ;copy of psess
mov pedi,pdword [pedi+psize*1] ;(R/E)CX => protocolName

mov peax,pdword [pesi+psize*5]	;get main parameter (LinkedlistControlPanelOptions structure)
test peax,peax
cmovz peax,pedi ;set protocolName if main (LinkedlistControlPanelOptions) does not exist
jz endGetProtocolVisibleName

mov peax,pdword [peax+psize+4*2+psize] ;optionName
test peax,peax
cmovz peax,pedi ;set protocolName if optionName in main (LinkedlistControlPanelOptions) does not exist

endGetProtocolVisibleName:
call dleave
ret psize*1

;------------------------------------------------------------------------------
;This function will replace tag %protocols_receiver%, %protocols_manipulator% and %protocols_laborer%
;by a list of protocols from a specifik type (formated by element "protocol_drop_down_item"
;input:
;    1:psess
;    2:lsess
;    3:type
;output:
;    none
;------------------------------------------------------------------------------
sendProtocolsByType:
call denter

sub pesp,(AMMOUNT_OF_TAGS*psize)+24+24 ;create an array with pointer to replace tags with  and 2 temp strings

;zero structure with pointers for tags
mov ecx,AMMOUNT_OF_TAGS+(24/psize)+(24/psize)
mov pedi,pesp
xor eax,eax
rep stosp

mov edx,dword [pebp+psize*4] ;EDI = type of protocol

;lock linked-list with internal protocol structures
call GetInternalProtocolstructureReadLock

mov pesi,[cpyInternalProtocolstructure] ;pointer to first internal protocol structure

loopProtocolsByType:
  mov ecx,dword [pesi+(psize*7)+4] ;type(lower part of ECX => cl) & flags
  cmp cl,dl
  jne nextLoopProtocolsByType ;jump if the types to not match

    push pesi
    call getProtocolVisibleName
    mov pdword [pesp],peax ;set %name_of_value%

    lea pedi,pdword [pesp+psize*AMMOUNT_OF_TAGS] ;get pointer to first temp string

    push 10		     ;base at 10
    push pedi		     ;output string
    push pdword [pesi+psize] ;protocol session
    call IntToStr
    mov pdword [esp+psize],pedi ;set %id_of_value%

    lea pedi,pdword [pesp+(psize*AMMOUNT_OF_TAGS)+24] ;get pointer to second temp string

    push 10		     ;base at 10
    push pedi		     ;output string
    push pecx		     ;flags
    call IntToStr
    mov pdword [esp+psize*2],pedi ;set %value%

    push pesp		       ;tag list
    push 0		       ;ignore and start tags
    push pdword [parsed_elements+(protocol_drop_down_item_index*psize)] ;pointer to parsed string
    push pdword [pebp+psize*3] ;lsess
    push pdword [pebp+psize*2] ;psess
    call ParseAndSendByList

nextLoopProtocolsByType:
    lodsp ;get next internal protocol structure
    mov pesi,peax
    test pesi,pesi
jnz loopProtocolsByType


;unlock linked-list with internal protocol structures
call ReleaseInternalProtocolstructureReadLock

call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will send the page and replace the th bytes (starting with byte '1') while sending
;input:
;    1:psess
;    2:lsess
;    3:pointer to parsed string (on stack return: last position of parsed string)
;    4:stop at tag[8bits):stop at tag[8bits):stop at tag[8bits):start sending from tag(8 bits)
;    5:tags list
;output:
;    none
;------------------------------------------------------------------------------
ParseAndSendByList:
call denter

mov pedi,pdword [pebp+psize*4] ;(R/E)DI => pointer to parsed string
mov pebx,pdword [pebp+psize*6] ;(R/E)BX => list with tags replacements
mov pesi,pedi		       ;backup of parsed page
push pedi
call strlen
mov pecx,peax ;(R/E)CX = size of parsed string
mov pedx,pecx ;(R/E)DX = backup of size

loopParsedString:
  mov al,1 ;1=tag byte
  repnz scasb ;search for tag byte
  jnz sendLastPartOfString

  sub pedx,pecx ;send scaned size
  dec pedx ;decrement the found '1' byte

  mov al,byte [pebp+(psize*5)+3] ;start tag
  test al,al
  jz NoStartTag ;continue processing string since there is not start tag

    cmp al,byte [pedi] ;should we ignore all data before this tag?
    jne nextLoopParsedString ;skip this tag

    mov pdword [pebp+(psize*5)+3],0  ;delete start tag
    jmp nextLoopParsedString

NoStartTag:
  test pedx,pedx
  jz noDataToSendBeforeTag
    call shortSendDataEDX ;send ESI with size EDX
    jnz endParseAndSendByList ;jump if lost connection
  noDataToSendBeforeTag:

  xor eax,eax
  mov al,byte [pedi] ;get indicator of the tag we need to replace
  cmp al,AMMOUNT_OF_TAGS
  ja nextLoopParsedString ;jump if this is an invalid tag

  cmp al,byte [pebp+psize*5] ;should we stop processing
  je endParseAndSendByList ;stop processing string at this tag

  cmp al,byte [pebp+(psize*5)+1] ;should we stop processing
  je endParseAndSendByList ;stop processing string at this tag

  cmp al,byte [pebp+(psize*5)+2] ;should we stop processing
  je endParseAndSendByList ;stop processing string at this tag

  dec al ;item 1 is index 0, so -1
  mov peax,[pebx+(psize*peax)] ;get pointer to the tag replacement
  test peax,peax
  jz nextLoopParsedString ;jump, there is no replacement

  ;call shortSendString ;send string (R/E)AX
  ;Escape string and send (R/E)AX
  call shortSendStringEcape

nextLoopParsedString:
  ;skip the indicator of the tag
  inc pedi
  sub pecx,1

  mov pesi,pedi ;EDI = copy ESI
  mov pedx,pecx ;ECX = copy EDX
jc endParseAndSendByList
jnz loopParsedString

jmp endParseAndSendByList

sendLastPartOfString:
  sub pedx,pecx ;send scaned size
  jz endParseAndSendByList

  call shortSendDataEDX ;send ESI with size EDX

endParseAndSendByList:
mov pdword [pebp+psize*4],pedi
call dleave
ret psize*5

;------------------------------------------------------------------------------
;This function will generate the menu from active Listensessions
;input:
;    none
;output:
;    pointer to string menu
;------------------------------------------------------------------------------
GenerateMenuListenSessions:
call denter

;get lock on internal ProtocolStructure
call GetInternalProtocolstructureReadLock

;lock list with internalListenStructures
push [cpyInternalListenSessionstructureCollection]
call LockListWriteAcces

;create space for a dword to integer conversion
sub pesp,0x10
mov pedx,pesp

sub pesp,AMMOUNT_OF_TAGS*psize ;create an array with pointer to replace tags with

;zero structure with pointers for tags
mov ecx,AMMOUNT_OF_TAGS+(0x10/psize)
mov pedi,pesp
xor eax,eax
rep stosp

mov pdword [pesp+psize],pedx ;set %id_of_value% with empty buffer (will be used by IntToStr)
;--mov pdword [pesp],pedx ;set %name_of_value% with empty buffer (will be used by IntToStr)

;get smallest size to allocate
call GetSmallestPortionPageAllocation
if used is32
  mov edx,eax ;EDX => size of buffer EDI
else
  mov r12,rax ;R12 => size of buffer RDI
end if
mov pecx,peax ;(R/E)CX => free size of buffer (R/E)DI

;allocate memory for buffer
push pedx
call GetMemLocation
mov pedi,peax

push [cpyInternalListenSessionstructureCollection]
call CountItems
mov pesi,peax ;index of the current ListenSession
shr pesi,1 ;ESI = ESI / 2. Divide by two because the items are indexed by the Listensession (lsess) and we shouldn't count those.
test peax,peax
jz endGenerateMenuListenSessions

loopListenSessions:
  mov peax,pesi
  shl eax,1 ;EAX => counter *=2 to get index in list
  dec eax ;id for ListenSession

  ;get current Listensession
  push peax
  push [cpyInternalListenSessionstructureCollection]  ;collection
  call GetDwordItem

  ;convert listenSession to string and replace tag id_of_value with this one
  push 10   ;base => 10
  push pdword [pesp+psize*2] ;buffer from %id_of_value%
  push peax ;ListenSession
  call IntToStr

  mov peax,pesi
  shl eax,1 ;EAX => counter *=2 to get index in list

  ;get current InternalListenSession
  push peax
  push [cpyInternalListenSessionstructureCollection]  ;collection
  call GetDwordItem

  push peax ;save InternalListenSession

    mov peax,pdword [peax+(5*psize)+8+psize] ;(R/E)AX => InternalListenSession->name
    mov pdword [pesp+psize],peax     ;set %name_of_value%

  pop peax ;restore InternalListenSession

  push pdword [pesp+psize] ;buffer from %id_of_value% (lsess)
  push pdword [peax] ;get pointer bindedToHandles structure
  call GenerateMenuSubmenuFromBindedToHandle
  mov pdword [pesp+psize*18],peax ;set %groupitems%

  push pesp					;tags
  push pdword [parsed_elements+(menu_listensession_group_index*psize)] ;input string
  call replaceTags

  mov peax,pdword [pesp+psize*18] ;%groupitems%
  test peax,peax
  jz nextLoopListenSessions

    push peax
    call FreeMemLocation

nextLoopListenSessions:
  dec pesi
jnz loopListenSessions

endGenerateMenuListenSessions:
  ;release lock on internal ProtocolStructure
  call ReleaseInternalProtocolstructureReadLock

  ;unlock list with internalListenStructures
  push [cpyInternalListenSessionstructureCollection]
  call ExternalUnlockListWriteAcces

  ;(R/E)DI => base of buffer
  if used is32
    sub edi,edx
  else
    sub rdi,r12
  end if
  add pedi,pecx

  mov peax,pedi

call dleave
ret

;------------------------------------------------------------------------------
;This function will generate the menu from active ProtocolSessions
;input:
;    1:pointer tobindedToHandles structure
;    2:lsess as string
;output:
;    pointer to string menu
;------------------------------------------------------------------------------
GenerateMenuSubmenuFromBindedToHandle:
call denter

sub pesp,(AMMOUNT_OF_TAGS*psize)+24 ;create an array with pointer to replace tags with + temp string

;zero structure with pointers for tags + temp string
mov ecx,AMMOUNT_OF_TAGS+(24/psize)
mov pedi,pesp
xor eax,eax
rep stosp

mov pesi,pdword [pebp+psize*2] ;pointer tobindedToHandles structure

;get smallest size to allocate
call GetSmallestPortionPageAllocation
if used is32
  mov edx,eax ;EDX => size of buffer EDI
else
  mov r12,rax ;R12 => size of buffer RDI
end if
mov pecx,peax ;(R/E)CX => free size of buffer (R/E)DI

;allocate memory for buffer
push pedx
call GetMemLocation
mov pedi,peax

lodsp ;get count of BindedToProtocols
mov pebx,peax ;(R/E)DX => ammount of binded protocols

loopThroughBindedToHandles:
  lodsp ;get next protocolSession of one of the binded protocols

  if used is32
    push edx ;save EDX
    push esi ;save ESI
  end if

  ;get internal protocolstructure from a protocolsession
  push peax ;psess
  call GetInternalProtocolStructure
  if used is32
    mov esi,eax ;ESI => internal protocolStructure
  else
    mov r13,rax ;R13 => internal protocolStructure
  end if

  ;Protocolsession -> string
  push 10 ;base
  push pesp
  if used is32
    add dword [esp],(3*psize)+(AMMOUNT_OF_TAGS*psize) ;pointer to tmep string => add the pushed 10, EDX and ESI, skip the list with tags
  else
    add qword [rsp],(1*psize)+(AMMOUNT_OF_TAGS*psize) ;pointer to tmep string => add the pushed 10, skip the list with tags
  end if
  push pdword [peax+psize] ;protocolsession
  call IntToStr

  if used is32
    push esi
  else
    push r13
  end if
  call getProtocolVisibleName

  if used is32
    mov pdword [pesp+psize*2],peax ;set %name_of_value%

    mov pedx,pdword [pebp+psize*3] ;lsess as string
    mov pdword [pesp+psize*3],pedx ;set %id_of_value%


    lea pedx,pdword [pesp+(2*psize)+(AMMOUNT_OF_TAGS*psize)] ;string with protocolsession
    mov pdword [pesp+psize*4],pedx ;set %value%
  else
    mov pdword [pesp],peax ;set %name_of_value%

    mov pedx,pdword [pebp+psize*3] ;lsess as string
    mov pdword [pesp+psize],pedx ;set %id_of_value%

    lea pedx,pdword [pesp+(AMMOUNT_OF_TAGS*psize)] ;string with protocolsession
    mov pdword [pesp+psize*2],pedx ;set %value%
  end if

  if used is32
    mov peax,pdword [pesi+psize*6] ;subOptions parameter (LinkedlistControlPanelOptions structure)
    pop esi ;restore esi
    pop edx ;restore EDX
  else
    mov peax,pdword [r13+psize*6] ;subOptions parameter (LinkedlistControlPanelOptions structure)
  end if

  push pdword [parsed_elements+(menu_listensession_item_index*psize)] ;input string
  push CPO_GEN_LISTENSESSION_OPTION				      ;flags that have to match the subOptions
  push peax							      ;subOptions
  call GenerateMenuSubCategories
  mov pdword [pesp+psize*18],peax ;set %groupitems%

  push pesp					;tags
  push pdword [parsed_elements+(menu_listensession_group_index*psize)] ;input string
  call replaceTags

  mov peax,pdword [pesp+psize*18] ;%groupitems%
  test peax,peax
  jz nextloopThroughBindedToHandles

  push peax
  call FreeMemLocation

nextloopThroughBindedToHandles:
  dec pebx
jnz loopThroughBindedToHandles

endloopThroughBindedToHandles:

;(R/E)DI => base of buffer
if used is32
  sub edi,edx
else
  sub rdi,r12
end if
add pedi,pecx

mov peax,pedi

endGenerateMenuSubmenuFromBindedToHandle:
call dleave
ret psize*2

;------------------------------------------------------------------------------
;This function will generate the menu from active ProtocolSessions
;input:
;    none
;output:
;    pointer to string menu
;------------------------------------------------------------------------------
GenerateMenuProtocols:
call denter

;;get lock on internal ProtocolStructure
;call GetInternalProtocolstructureReadLock

sub pesp,(AMMOUNT_OF_TAGS*psize)+24 ;create an array with pointer to replace tags with + one temp string

;zero structure with pointers for tags
mov ecx,AMMOUNT_OF_TAGS+(24/psize)
mov pedi,pesp
xor eax,eax
rep stosp

mov pesi,[cpyInternalProtocolstructure] ;linked list with internal protocol structures

;get smallest size to allocate
call GetSmallestPortionPageAllocation
if used is32
  mov edx,eax ;EDX => size of buffer EDI
else
  mov r12,rax ;R12 => size of buffer RDI
end if
mov pecx,peax ;(R/E)CX => free size of buffer (R/E)DI

;allocate memory for buffer
push pedx
call GetMemLocation
mov pedi,peax

loopProtocols:
  if used is32
    push edx ;save EDX
  end if

  lodsp ;get pointer to next internalProtocoStructure
  mov pebx,peax ;(R/E)BX => pointer to next internalProtocolStructure

  lodsp ;psess

  push 10 ;base
  push pesp
  if used is32
    add dword [esp],(2*psize)+(AMMOUNT_OF_TAGS*psize) ;pointer to tmep string => add the pushed 10 and EDX, skip the list with tags
  else
    add qword [rsp],(1*psize)+(AMMOUNT_OF_TAGS*psize) ;pointer to tmep string => add the pushed 10, skip the list with tags
  end if
  push peax ;protocolsession
  call IntToStr


  lodsp ;copy of psess
  mov pedx,pdword [peax+psize*1] ;(R/E)CX => protocolName

  add pesi,psize*2  ;skip 2 reserved parameters
  lodsp 	   ;get main parameter (LinkedlistControlPanelOptions structure)
  test peax,peax
  cmovz peax,pedx ;set protocolName if main (LinkedlistControlPanelOptions) does not exist
  jz protocolNameIsSet

  mov peax,pdword [peax+psize+4*2+psize] ;optionName
  test peax,peax
  cmovz peax,pedx ;set protocolName if optionName in main (LinkedlistControlPanelOptions) does not exist

  protocolNameIsSet:
  if used is32
    mov pdword [pesp+psize],peax ;set %name_of_value%

    lea edx,dword [esp+(1*psize)+(AMMOUNT_OF_TAGS*psize)]  ;pointer to tmep string
    mov pdword [pesp+psize*2],pedx ;set %id_of_value%
  else
    mov pdword [pesp],peax ;set %name_of_value%

    lea rdx,qword [rsp+(0*psize)+(AMMOUNT_OF_TAGS*psize)]  ;pointer to tmep string
    mov pdword [pesp+psize],pedx ;set %id_of_value%
  end if

  if used is32
    pop edx ;restore EDX
  end if

  lodsp ;get subOptions parameter (LinkedlistControlPanelOptions structure)

  push pdword [parsed_elements+(menu_protocols_item_index*psize)] ;input string
  push CPO_GEN_PROTOCOL_OPTION or CPO_SHOW_IN_MENU	;flags that have to match the subOptions
  push peax						;subOptions
  call GenerateMenuSubCategories
  mov pdword [pesp+psize*18],peax ;set %groupitems%

  push pesp					;tags
  push pdword [parsed_elements+(menu_protocols_group_index*psize)] ;input string
  call replaceTags

  mov peax,pdword [pesp+psize*18] ;%groupitems%
  test peax,peax
  jz nextLoopProtocols

  push peax
  call FreeMemLocation

nextLoopProtocols:
  mov pesi,pebx ;(R/E)SI => next internalPotocolStructure
  test pesi,pesi
jnz loopProtocols

;;release lock on internal ProtocolStructure
;call ReleaseInternalProtocolstructureReadLock

;(R/E)DI => base of buffer
if used is32
  sub edi,edx
else
  sub rdi,r12
end if
add pedi,pecx

mov peax,pedi

endGenerateMenu:
call dleave
ret

;------------------------------------------------------------------------------
;This function will generate the menu from sub items from a protocol
;input:
;    1:subOptions (LinkedlistControlPanelOptions)
;    2:flags to include
;            CPO_SHOW_IN_MENU
;            CPO_GEN_PROTOCOL_OPTION
;            CPO_GEN_LISTENSESSION_OPTION
;    3:input string
;output:
;    pointer to string menu
;------------------------------------------------------------------------------
GenerateMenuSubCategories:
call denter

sub pesp,AMMOUNT_OF_TAGS*psize ;create an array with pointer to replace tags with

;zero structure with pointers for tags
mov ecx,AMMOUNT_OF_TAGS
mov pedi,pesp
xor eax,eax
rep stosp

mov pebx,pesp	;(R/E)BX => pointer to structure with tags
mov pesi,pdword [pebp+psize*2] ;subOptions (LinkedlistControlPanelOptions)
test pesi,pesi
jz endGenerateMenuSubCategories


;get smallest size to allocate
call GetSmallestPortionPageAllocation
if used is32
  mov edx,eax ;EDX => size of buffer EDI
else
  mov r12,rax ;R12 => size of buffer RDI
end if
mov pecx,peax ;(R/E)CX => free size of buffer (R/E)DI

;allocate memory for buffer
push pedx
call GetMemLocation
mov pedi,peax

push 0 ;push zero that indicates the end of pushed hashes

loopSubOptions:
  mov eax,dword [pebp+psize*3] ;EAX = flags
  test dword [pesi+psize+4],eax
  jz nextLoopSubOptions ;if the flags do not meet, get next subOption

  test dword [pesi+psize+4],CPO_SHOW_IN_MENU
  jz NoShowInMenuFlagSet ;CPO_SHOW_IN_MENU is not supported yet

  mov peax,pdword [pesi+psize+8+(psize*1)] ;optionName
  mov pdword [pebx],peax ;set %name_of_value%

    mov peax,pdword [pesi+psize+8+(psize*6)] ;menuURL
    mov pdword [pebx+psize*2],peax ;set %value%

    push pebx	;tags
    push pdword [parsed_elements+(menu_item_link_index*psize)] ;input string
    call replaceTags
    jmp nextLoopSubOptions

NoShowInMenuFlagSet:

  mov peax,pdword [pesi+psize+8+(psize*3)] ;groupname
  mov pdword [pebx],peax ;set %name_of_value%

  test peax,peax
  jz nextLoopSubOptions

  ;generate hash of this groupname
  push peax
  call GenerateHashCaseInsensitiveSafe

  push pecx ;save (R/E)CX

  mov pecx,pesp
  cmp pdword [pecx],0
  je endCheckOnGroupHash

  ;check if the hash already exist
  checkOnGroupHash:
    cmp pdword [pecx],peax
    je foundGroupHash

    add pecx,psize ;get next groupHash
    cmp pdword [pecx],0
  jne checkOnGroupHash

endCheckOnGroupHash:
  pop pecx ;restore (R/E)CX
  jmp addGroupToMenu


foundGroupHash:
  pop pecx ;restore (R/E)CX
  jmp nextLoopSubOptions

addGroupToMenu:
  push peax

  push pebx					;tags
  push pdword [pebp+psize*4] ;input string
  call replaceTags

nextLoopSubOptions:
  mov pesi,pdword [pesi] ;(R/E)SI => next LinkedlistControlPanelOptions
  test pesi,pesi
jnz loopSubOptions

;(R/E)DI => base of buffer
if used is32
  sub edi,edx
else
  sub rdi,r12
end if
add pedi,pecx

mov peax,pedi

endGenerateMenuSubCategories:
call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will replace the tags set by function PreParseElement
;input:
;    1:input string
;    2:tags

;    (R/E)DI: buffer to copy to
;    R12 / (R/E)DX: size of buffer
;    (R/E)CX: free size of buffer
;output:
;    none
;------------------------------------------------------------------------------
replaceTags:
push pebp
mov pebp,pesp
push pesi ;save (R/E)SI
push pebx ;save (R/E)BX

xchg pedi,pdword [pebp+psize*2] ;swap buffer to copy too with the (R/E)DI=(input string)

;calculate the size of the input string
push pedi
call strlen

push pecx ;save free size of buffer
mov pecx,peax ;R/ECX => size of input string

loopReplaceTags:
  push pedi  ;push for writeToFlexibleBuffer

  mov al,1 ;look for the tag
  repnz scasb ;scan string for tags
  jnz cpyLastPartOfInputString

  ;calculate the size
  mov peax,pedi ;(R/E)AX => current pos
  sub peax, pdword [pesp] ;(R/E)AX => current pos - old pos => size of just scanned part of the string
  dec peax ;substract the '1' byte

  xchg pecx,pdword [pesp+psize] ;swap size of input string with (R/E)CX=(free size of buffer)
  xchg pedi,pdword [pebp+psize*2] ;swap (R/E)DI=(buffer to copy too) with the input string

  ;push str (already done)
  push peax ;size to copy
  call writeToFlexibleBuffer

  xchg pecx,pdword [pesp] ;swap (R/E)CX=(size of input string) with free size of buffer
  xchg pedi,pdword [pebp+psize*2] ;swap buffer to copy too with (R/E)DI=(the input string)

  xor eax,eax
  mov al,byte [pedi]	;get the tag id
  inc pedi
  dec pecx ;decrement since we received the tag index
  cmp al,AMMOUNT_OF_TAGS+1
  jnc nextLoopReplaceTags ;the tag is unknown, skip it

  dec eax ;decrement index (we start counting at zero )

  mov pesi,pdword [pebp+psize*3]    ;tags
  mov pesi,pdword [pesi+psize*peax] ;get the value that belongs to this tag
  test pesi,pesi
  jz nextLoopReplaceTags ;nothing to replace the tag with

  ;calculate the size of the value
  push pesi
  call strlen

  xchg pecx,pdword [pesp] ;swap size of input string with (R/E)CX=(free size of buffer)
  xchg pedi,pdword [pebp+psize*2] ;swap (R/E)DI=(buffer to copy too) with the input string

  ;add tag value to buffer
  push pesi
  push peax
  call writeToFlexibleBuffer

  xchg pecx,pdword [pesp] ;swap (R/E)CX=(size of input string) with free size of buffer
  xchg pedi,pdword [pebp+psize*2] ;swap buffer to copy too with (R/E)DI=(the input string)


nextLoopReplaceTags:
  jmp loopReplaceTags

cpyLastPartOfInputString:
;calculate the size
mov peax,pedi ;(R/E)AX => current pos
sub peax, pdword [pesp] ;(R/E)AX => current pos - old pos => size of just scanned part of the string
;dec peax ;substract the '1' byte

xchg pecx,pdword [pesp+psize] ;swap size of input string with (R/E)CX=(free size of buffer)
xchg pedi,pdword [pebp+psize*2] ;swap (R/E)DI=(buffer to copy too) with the input string

;push str (already done
push peax ;size to copy
call writeToFlexibleBuffer

add pesp,psize ;remove size of input string of stack

pop pebx ;restore (R/E)BX
pop pesi ;restore (R/E)SI
mov pesp,pebp
pop pebp
ret psize*2

;------------------------------------------------------------------------------
;This function will write source (R/E)SI to buffer (R/E)DI with size (R/E)CX and resize if buffer size is not reaching out
;input:
;    1:size to copy
;    2:source string to copy to buffer

;    (R/E)DI: buffer to copy to
;    R12 / (R/E)DX: size of buffer
;    (R/E)CX: free size of buffer
;output:
;    none
;corrupts:
;       (R/E)AX
;------------------------------------------------------------------------------
writeToFlexibleBuffer:
mov peax,pdword [pesp+psize*1] ;size to copy

cmp pecx,peax
jnc enoughFreeBufferSpace   ;jump if free size - needed size does not overflow

    ;(R/E)DI => base of buffer
    if used is32
      sub edi,edx
    else
      sub rdi,r12
    end if
    add pedi,pecx

    ;get smallest size to allocate
    call GetSmallestPortionPageAllocation

    notEnoughSizeInBuffer2:
      add pecx,peax	;(R/E)CX => add free size of buffer (R/E)BX
      if used is32
	add edx,eax	;EDX => add size of buffer (R/E)BX
	cmp edx,edi
      else
	add r12,rax	;R12 => add size of buffer (R/E)BX
	cmp r12,rdi
      end if
    jc notEnoughSizeInBuffer2 ;we dont need to resize the buffer

    if used is32
      push edx ;new requierd size
    else
      push r12 ;new requierd size
    end if
    push pedi ;base of buffer
    call ReAllocMemPage
    mov pedi,peax ;set new pointer to buffer

    ;calculate pos of buffer
    if used is32
      add edi,edx
    else
      add rdi,r12
    end if
    sub pedi,pecx

    ;calculate size to copy
    mov peax,pdword [pesp+psize*1] ;size to copy

enoughFreeBufferSpace:
sub pecx,peax ;decrement the size that you write to buffer

push pecx ;save (R/E)CX
push pesi ;save (R/E)SI

mov pesi,pdword [pesp+psize*4] ;source string to copy to buffer
mov pecx,peax
rep movsb

pop pesi  ;restore (R/E)SI
pop pecx  ;restore (R/E)CX

ret psize*2