
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will initialize the ListenSession
;------------------------------------------------------------------------------
BindToProtocolCallBack:
StartProc 3 ;param len is not set on stack
call denter

xor eax,eax ;return value

mov pecx,pdword [pebp+(psize*2)] ;psess
cmp [psess_TCP],pecx
jne endBindToProtocolCallBack

;get the port to listen to from the listensession
xor esi,esi		   ;flags (0x0 = listensession)
mov eax,option_port	      ;name
call GetPluginDataInt
mov ebx,ecx ;EBX = ECX = the listenport

;return if GetPluginData resulted in an error
test eax,eax
jz endBindToProtocolCallBack

;get the option TCP/IP v6 from the ListenSession
mov eax,option_v6	    ;name
call GetPluginDataInt
;ECX = TCP/IP v6 boolean
mov edx,ecx ;EDX = TCP/IP v6 boolean
shl edx,4 ;EDX = EDX * 16
add edx,0x10 ;EDX = sizeof sockadr_in

;return if GetPluginData resulted in an error
test eax,eax
jz endBindToProtocolCallBack

;Start listening socket
push pebx		;Port to listen to
push pecx		;flags
call CreateSocket
test peax,peax
jz endBindToProtocolCallBack
mov pebx,peax

mov peax,pdword [pebp+psize*3]
mov peax,pdword [peax+8] ;data member

;find the data member of this protocol
mov pecx,pdword [pebp+psize*3]	;lsess

push pdword [pecx+8]	   ;ProtocolData structure
push pdword [pebp+psize*2] ;psess
call [FindProtocolDataStruct]
mov pdword [peax+psize*2],pebx ;Write the socket to it
mov pdword [peax+psize*3],pedx	;Write size of sockaddr_in to it
mov pdword [peax+psize*3+psize+0x20],pedx  ;Write secondsize of sockaddr_in to it

push pdword [pebp+psize*3] ;lsess
push pdword [pebp+psize*2] ;psess
call [RequestToBindToNextProtocol]
test eax,eax
jnz endBindToProtocolCallBack

push pebx
call CloseSocket

xor eax,eax

endBindToProtocolCallBack:
call dleave
EndProc 3
ret (FunctionReturnFactor*3)