
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

include 'include/function.inc'
include 'include/flags.inc'
include 'include/math.inc'
include 'include_plugin_general/short_functions.inc'
include 'include_tvs_server_plugin_tcp_protocol/plugin_handle_connection.inc'

EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_TCP equ psize*2 + 0x20 + psize + 0x20 ;We want 1 pointers in the Listen/Client session + sizeof(sockadr_in) and a sockaddr_in structure (remote addr) + sizeof(sockadr_in) and a sockaddr_in structure (local addr)

sizeSubportedProtocols equ endSubportedProtocols - subportedProtocols

option_port equ 3 ;integer instead of a name (option_1)
option_v6 equ 6   ;integer instead of a name (option_3)
option_author equ -1
option_version equ -2


include 'include_tvs_server_plugin_tcp_protocol/plugin_bind.inc'
include 'include_tvs_server_plugin_tcp_protocol/plugin_listen.inc'
;------------------------------
;-----GetProtocolNames---------
;-----__asm_exchange_tables----
;------------------------------
include 'include_plugin_general/__asm_exchange_tables_GetProtocolNames.inc'

;------------------------------------------------------------------------------
;The StartProtocol function need to initiate the protocol named in the ProtocolSession structure.
;------------------------------------------------------------------------------
StartProtocol:
StartProc 1
call denter

;Get the protocolName member from ProtocolSession
mov peax,pdword [pebp+(psize*2)]
mov peax,pdword[peax+(psize*1)]

;Do we init TCP/IP?
push tcpip
push peax
call strcmp
test eax,eax
jnz endStartProtocol

push V_TV_SERVER_1 ;version of protocol with TV's server
push EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_TCP ;extraSize
push 0 ;pSign
push PT_RECEIVER ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

push httpControlPanelOptions  ;cpo
push pdword [pebp+(psize*2)] ;psess
call [SetControlPanelOptions]

;initialize the SOCKET stack on the program
call initilize_socket_api
test eax,eax
jz endStartProtocol

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_TCP],pecx

;return
endStartProtocol:
call dleave
EndProc 1
ret (FunctionReturnFactor*1)