;------------------------------------------------------------------------------
;This function will initialize the ClientSession (if TCP) and handle the connection (if HTTP)
;------------------------------------------------------------------------------
HandleConnection:
StartProc 2 ;Set arguments on stack
call denter

xor eax,eax ;return value

mov pedx,pdword [pebp+psize*2]	;psess
mov pecx,pdword [pebp+psize*3]	;sess

cmp [psess_hello],pedx
je handle_hello

cmp [psess_quiet],pedx
jne endHandleConnection

handle_quiet:
;
;Handle QUIET
;

push 21

push pesp					    ;&len
if used isLinux
  lea peax,dword [response_quiet]
  push peax					    ;buff
else
  push response_quiet				    ;buff
end if
push DEFAULT_SENDTIMEOUT			    ;timeout
push 0						    ;flags
push pecx					    ;sess
push pedx					    ;psess
call [SendData]

add pesp,psize
jmp endEchoReceiveLoop

handle_hello:
;
;Handle HELLO
;
push REPLACE_SPACE_WITH_ADD_SIGN		    ;flags
push DEFAULT_SENDTIMEOUT			    ;timeout
push example					    ;buff
push pecx					    ;sess
push pedx					    ;psess
call [EscapeAndSendValue]

push 16

push pesp					    ;&len
if used isLinux
  lea peax,dword [response_hello]
  push peax					    ;buff
else
  push response_hello				    ;buff
end if
push DEFAULT_SENDTIMEOUT			    ;timeout
push 0						    ;flags
push pecx					    ;sess
push pedx					    ;psess
call [SendData]

add pesp,psize

endEchoReceiveLoop:

mov peax,pedi ;set return value back
endHandleConnection:
call dleave
EndProc 2
ret (FunctionReturnFactor*2)