format PE64 GUI 4.0 DLL

section '.text' code data readable writeable executable
db "TV's server 3.00"
dq __asm_exchange_tables

include '../windows/Use64.inc'
include '../include/flags.inc'
;include 'windows/register.inc'       ;HTTP protocol
;include 'windows/callconvention.inc' ;HTTP protocol
;include 'windows/timedate.inc'       ;HTTP protocol
;include 'windows/fileFunctions.inc'  ;HTTP protocol
include '../windows/memfunctions.inc'
include 'include_plugin_only/plugin_test_base.asm'
include '../windows/threadfunctions.inc'
include '../windows/user.inc'
include '../windows/sockets.inc'
include 'include_plugin_only/plugin_export_list.inc'
include 'include_plugin_only/readable_writeable_data.inc'

;psess_HTTP pointer ?
;psess_TCP pointer ?

;section '.edata' export data readable
;
;  export 'plugin_test_x64.DLL',\
;         __asm_exchange_tables,'__asm_exchange_tables'

data import
library kernel32,'KERNEL32.DLL',\
	advapi32,'ADVAPI32.DLL',\
	 user32,'USER32.DLL',\
	 gdi32,'gdi32.dll',\
	 winmm,'WINMM.DLL',\
	 errormsg,'ERRORMSG.DLL',\
	 wsock32,'WS2_32.DLL',\
	 ntdll,'NTDLL.dll',\
	 Ntoskrnl,'Ntoskrnl.exe',\
	 tvHttpProtocol,'tvs_server_http_protocol_x64.DLL'

include 'API\KERNEL32.INC'
include 'API\USER32.INC'
include 'API\gdi32.INC'
include 'API\ADVAPI32.INC'
include '../windows/adapted_WSOCK32.INC'

import errormsg,\
	 ShowLastError,'ShowLastError'

import winmm,\
	 mciSendString,'mciSendStringA',\
	 PlaySound,'PlaySoundA'

import ntdll,\
       InterlockedCompareExchange64,'RtlInterlockedCompareExchange64',\
       RtlRestoreContext,'RtlRestoreContext'

import Ntoskrnl,\
       MmSecureVirtualMemory,'MmSecureVirtualMemory'

import tvHttpProtocol,\
	 __asm_exchange_tables_HTTP_PROTOCOL,'__asm_exchange_tables',\
	 RecvAndParseHTTP, 'RecvAndParseHTTP',\
	 FreeHTTPSession, 'FreeHTTPSession',\
	 SendHTTPHeader, 'SendHTTPHeader',\
	 ConvertEscapedCharactersToBytes, 'ConvertEscapedCharactersToBytes',\
	 GetCollectionItem,'GetCollectionItem',\
	 EscapeAndSendValue,'EscapeAndSendValue',\
	 DeleteDoubleSlashesInUrl,'DeleteDoubleSlashesInUrl',\
	 DecodeURL,'DecodeURL'

end data

section '.reloc' fixups data readable discardable