
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

subportedProtocols:
http_name db 'TVS_SOFTWARE_HTTP',0
db 0
endSubportedProtocols:

protocolName db "HTTP protocol",0


HTTP_psign:
dd 3	  ;size 'GET'
db 'GET'
dd 4	  ;size 'POST'
db 'POST'
dd 4	  ;size'HEAD'
db 'HEAD'
dd 0 ;end list

;----------userValue Option 0
option_0_displayname db 'Path',0
option_0_defaultValue db 'C:\WWWroot\',0
endoption_0_defaultValue:

;-- userValue option 0
option_0_default_struct:
dd TD_ASCII_STRING
dd endoption_0_defaultValue-option_0_defaultValue
pointer option_0_defaultValue  ;<- default value
;-- userValue end option 0

;----------userValue Option 1
option_1_displayname db 'Redirections',0
option_1_column1_name db 'Domain',0
option_1_column2_name db 'Path',0
option_1_column3_name db 'Redirect to',0

option_1_column1_value db '*',0
endOption_1_column1_value:
option_1_column2_value db '/',0
endOption_1_column2_value:
option_1_column3_value db 'http://www.',0
endOption_1_column3_value:

;a MultiColumnList structure
option_1_defaultValue:
dd endOption_1_defaultValue-option_1_defaultValue
dd 0 ;flags

;column1:
pointer option_1_column1_name ;option Name
dd TD_ASCII_STRING ;type
dd endOption_1_column1_value-option_1_column1_value ;size
pointer option_1_column1_value ;defaultValue

;column2:
pointer option_1_column2_name ;option Name
dd TD_ASCII_STRING ;type
dd endOption_1_column2_value-option_1_column2_value ;size
pointer option_1_column2_value ;defaultValue

;column3:
pointer option_1_column3_name ;option Name
dd TD_ASCII_STRING ;type
dd endOption_1_column3_value-option_1_column3_value ;size
pointer option_1_column3_value ;defaultValue

pointer 0 ;no default rows
endOption_1_defaultValue:

;-- userValue option 1
option_1_default_struct:
dd TD_LIST
dd endOption_1_defaultValue-option_1_defaultValue
pointer option_1_defaultValue  ;<- default value
;-- userValue end option 1

;---------------------------------------------------------------------------------------------

;----------userValue Option 2
option_2_displayname db 'CGI-applications',0
option_2_column1_name db 'Domain',0
option_2_column2_name db 'Extension',0
option_2_column3_name db 'CGI-path',0

option_2_column1_value db '*',0
endOption_2_column1_value:
option_2_column2_value db 'php',0
endOption_2_column2_value:
option_2_column3_value db 0
endOption_2_column3_value:

;a MultiColumnList structure
option_2_defaultValue:
dd endOption_2_defaultValue-option_2_defaultValue
dd 0 ;flags

;column1:
pointer option_2_column1_name ;option Name
dd TD_ASCII_STRING ;type
dd endOption_2_column1_value-option_2_column1_value ;size
pointer option_2_column1_value ;defaultValue

;column2:
pointer option_2_column2_name ;option Name
dd TD_ASCII_STRING ;type
dd endOption_2_column2_value-option_2_column2_value ;size
pointer option_2_column2_value ;defaultValue

;column3:
pointer option_2_column3_name ;option Name
dd TD_ASCII_STRING ;type
dd endOption_2_column3_value-option_2_column3_value ;size
pointer option_2_column3_value ;defaultValue

pointer 0 ;no default rows
endOption_2_defaultValue:

;-- userValue option 1
option_2_default_struct:
dd TD_LIST
dd endOption_2_defaultValue-option_2_defaultValue
pointer option_2_defaultValue  ;<- default value
;-- userValue end option 1

;------------------------------------------------------------------------------------------------------------


;----------userValue Option 3
option_3_displayname db 'Directory Listening',0

;-- userValue option 2
option_3_default_struct:
dd TD_BOOLEAN
dd 0
pointer 1  ;<- default value (=TRUE)
;-- userValue end option 2

;----------userValue Option 3
option_4_displayname db 'Maximum receive buffer (bytes)',0

;-- userValue option 3
option_4_default_struct:
dd TD_INTEGER
dd 0
pointer 1024*1024*5  ;<- default value (=5MB)
;-- userValue end option 3

;----------userValue Option 4
option_5_displayname db 'Maximum timeout (milliseconds)',0

;-- userValue option 3
option_5_default_struct:
dd TD_INTEGER
dd 0
pointer 1000*5	;<- default value (=5 seconds)
;-- userValue end option 4

;----------userValue Option 5
option_6_displayname db 'Send buffer (bytes)',0

;-- userValue option 5
option_6_default_struct:
dd TD_INTEGER
dd 0
defaultSendBuffer pointer 1024*1024*5  ;<- default value (=5MB)
;-- userValue end option 5

;----------userValue Option 7
option_7_displayname db 'Maximum CGI-runtime (milliseconds)',0

;-- userValue option 7
option_7_default_struct:
dd TD_INTEGER
dd 0
pointer 1000*15  ;<- default value (=15 seconds)
;-- userValue end option 7

;----------Option Author
option_author_displayname db 'Created by',0
author db 'Tycho Veltmeijer'

;-- userValue option 1
option_author_default_struct:
dd TD_ASCII_STRING
dd 0
pointer author	;<- default value
;-- userValue end option 3

;----------Option Author
option_version_displayname db 'Version',0
versionStr db '1.00'

;-- userValue option 1
option_version_default_struct:
dd TD_ASCII_STRING
dd 0
pointer versionStr  ;<- default value
;-- userValue end option 3

;httpOptions structure
httpOptions:
dd endHttpOptions-httpOptions ;size
dd 0;reserved
;--member main
dd 8 + (psize*2) ;size
dd GDPD_NAME_IS_INTEGER ;flags
pointer 0 ;name
pointer protocolName ;optionName
;--end main

;member subOptions[1]
suboption1:
dd endSuboption1-suboption1 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_REDIRECTIONS ;name
pointer option_1_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_1_default_struct ;userValue
endSuboption1:
;end subOptions[1]

;member subOptions[2]
suboption2:
dd endSuboption2-suboption2 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_CGI ;name
pointer option_2_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_2_default_struct ;userValue
endSuboption2:
;end subOptions[2]

;member subOptions[3]
suboption3:
dd endSuboption3-suboption3 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_DIRLISTEN ;name
pointer option_3_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_3_default_struct ;userValue
endSuboption3:
;end subOptions[3]

;member subOptions[6]
suboption6:
dd endSuboption6-suboption6 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_MAX_SIZE_SEND ;name
pointer option_6_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_6_default_struct ;userValue
endSuboption6:
;end subOptions[6]

;member subOptions[4]
suboption4:
dd endSuboption4-suboption4 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_MAX_SIZE ;name
pointer option_4_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_4_default_struct ;userValue
endSuboption4:
;end subOptions[4]

;member subOptions[7]
suboption7:
dd endSuboption7-suboption7 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_MAX_CGI_RUNTIME ;name
pointer option_7_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_7_default_struct ;userValue
endSuboption7:
;end subOptions[7]

;member subOptions[5]
suboption5:
dd endSuboption5-suboption5 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_MAX_TIMEOUT ;name
pointer option_5_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_5_default_struct ;userValue
endSuboption5:
;end subOptions[5]

;member subOptions[0]
suboption0:
dd endSuboption0-suboption0 ;size
dd CPO_GEN_LISTENSESSION_OPTION or GDPD_NAME_IS_INTEGER ;flags
pointer CPO_NAME_PATH ;name
pointer option_0_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_0_default_struct ;userValue
endSuboption0:
;end subOptions[0]

;member subOptions[8]
suboption8:
dd endSuboption8-suboption8 ;size
dd CPO_GEN_PROTOCOL_OPTION or GDPD_NAME_IS_INTEGER  or CPO_GEN_READONLY;flags
pointer CPO_NAME_VERSION ;name
pointer option_version_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_version_default_struct ;userValue
endSuboption8:
;end subOptions[8]

;member subOptions[9]
suboption9:
dd endSuboption9-suboption9 ;size
dd CPO_GEN_PROTOCOL_OPTION or GDPD_NAME_IS_INTEGER  or CPO_GEN_READONLY;flags
pointer CPO_NAME_AUTHOR ;name
pointer option_author_displayname ;optionName
pointer 0		     ;description
pointer 0 ;groupName
pointer 0 ;iconURL
pointer 0 ;bigIconURL
pointer 0 ;menuURL
pointer option_author_default_struct ;userValue
endSuboption9:
;end subOptions[9]
endHttpOptions:

psess_http pointer ?