
include '../include/function.inc'
include '../include/flags.inc'
include '../include/timedate.inc'	;HTTP protocol
include '../include/math.inc'
include '../include_plugin_general/short_functions.inc'
include 'include_plugin_only/plugin_handle_connection.inc'

EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_TCP equ psize*2 + 0x20 + psize + 0x20 ;We want 1 pointers in the Listen/Client session + sizeof(sockadr_in) and a sockaddr_in structure (remote addr) + sizeof(sockadr_in) and a sockaddr_in structure (local addr)
EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_HTTP equ psize

sizeSubportedProtocols equ endSubportedProtocols - subportedProtocols

option_1 equ 3 ;integer instead of a name
option_3 equ 6 ;integer instead of a name


include 'include_plugin_only/plugin_bind.inc'
include 'include_plugin_only/plugin_listen.inc'
include '../include_plugin_general/list_functions.inc'
include '../include/collection.inc'
;include 'include_plugin_only/plugin_http_splitter.inc'
;include 'include_plugin_only/plugin_http_responder.inc'
;------------------------------
;-----GetProtocolNames---------
;-----__asm_exchange_tables----
;------------------------------
virtual at 0
call initHTTPProtocol
initHTTPProtocol:
end virtual
include '../include_plugin_general/__asm_exchange_tables_GetProtocolNames.inc'

dfsdf db 'test',0

;------------------------------------------------------------------------------
;The StartProtocol function need to initiate the protocol named in the ProtocolSession structure.
;------------------------------------------------------------------------------
StartProtocol:
StartProc 1
call denter

;Get the protocolName member from ProtocolSession
mov peax,pdword [pebp+(psize*2)]
mov peax,pdword[peax+(psize*1)]

;Do we init TCP/IP?
if used isLinux
  lea pecx,dword [tcpip]
  push pecx
else
  push tcpip
end if
push peax
call strcmp
test eax,eax
jz initTCP

push V_TV_SERVER_1 ;version
push EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_HTTP ;extraSize
if used isLinux
  lea pecx,dword [HTTP_psign]
  push pecx
else
  push HTTP_psign ;pSign
end if
push PT_LABORER or PT_SUPPORT_PSIGN  ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_HTTP],pecx
jmp endStartProtocol

initTCP:
push V_TV_SERVER_1 ;version
push EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_TCP ;extraSize
push 0 ;pSign
push PT_RECEIVER ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

lea peax,dword [httpControlPanelOptions]

push peax		      ;cpo
push pdword [pebp+(psize*2)] ;psess
call [SetControlPanelOptions]

;initialize the SOCKET stack on the program
call initilize_socket_api
test eax,eax
jz endStartProtocol

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

;-mov eax,5 ;option_2
;-mov esi,0x2 or 0x4 ;GET_FROM_PROTOCOLSESSION or IS_LIST_POINTER
;-call GetPluginDataInt
;-mov pebx,pecx

;push 14
;push protocolName
;push 0
;push 1
;push pebx
;call [SetListItem]

;-push 0
;-push 1
;-push pebx
;-call GetListItemPointer

;-push 0
;-push peax
;-call message

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_TCP],pecx

;return
endStartProtocol:
call dleave
EndProc 1
ret (FunctionReturnFactor*1)