include '../include/function.inc'
include '../include/flags.inc'
include '../include_plugin_general/short_functions.inc'
include 'include_plugin_test2/plugin_handle_connection.inc'

EXTRASIZE_LISTEN_AND_CLIENT_STRUCT equ psize*2 ;We want 2 pointers in the Listen/Client session

sizeSubportedProtocols equ endSubportedProtocols - subportedProtocols


include 'include_plugin_test2/plugin_bind.inc'
include '../include_plugin_general/__asm_exchange_tables_GetProtocolNames.inc'

;------------------------------------------------------------------------------
;The StartProtocol function need to initiate the protocol named in the ProtocolSession structure.
;------------------------------------------------------------------------------
StartProtocol:
StartProc 1
call denter

;Get the protocolName member from ProtocolSession
mov peax,pdword [pebp+(psize*2)]
mov peax,pdword[peax+(psize*1)]

;Do we init HELLO_RESPONSE?
if used isLinux
  lea pecx,dword [HELLOP]
  push pecx
else
  push HELLOP
end if
push peax
call strcmp
test eax,eax
jz initHelloResponse

;init QUIET ?

push V_TV_SERVER_1 ;version
push EXTRASIZE_LISTEN_AND_CLIENT_STRUCT ;extraSize
push 0 ;pSign
push PT_LABORER  ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_quiet],pecx
jmp endStartProtocol

initHelloResponse:
push V_TV_SERVER_1 ;version
push EXTRASIZE_LISTEN_AND_CLIENT_STRUCT ;extraSize
if used isLinux
  lea pecx,dword [hello_psign]
  push pecx
else
  push hello_psign ;pSign
end if
push PT_LABORER or PT_SUPPORT_PSIGN  ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_hello],pecx

;return
endStartProtocol:
call dleave
EndProc 1
ret (FunctionReturnFactor*1)